Package: mlr3shiny
Title: Machine Learning in 'shiny' with 'mlr3'
Version: 0.5.0
Authors@R: 
    c(person(given = "Laurens",
           family = "Tetzlaff",
           role = c("aut", "cre"),
           email = "laurens.tetzlaff@outlook.de"),
     person(given = "Gero",
            family = "Szepannek",
            role = "aut",
            email = "gero.szepannek@web.de"),
     person(given = "Alexander",
            family = "Frahm",
            role = "aut"),
     person(given = "Dominic",
            family = "Henning",
            role = "aut",
            email  = "henning.dominic1705@gmail.com"),
	 person(given = "Jakob",
	 		family = "Steinbrink",
			role = "aut")
		)
Description: A web-based graphical user interface to provide the basic steps of a machine learning workflow. It uses the functionalities of the 'mlr3' framework.
License: BSD_2_clause + file LICENSE
Encoding: UTF-8
Depends: R (>= 3.6)
Imports: mlr3 (>= 0.12.0), mlr3measures (>= 0.3.1), mlr3learners,
        mlr3pipelines, mlr3viz, Metrics, shiny (>= 1.6.0),
        shinydashboard, shinyjs (>= 2.0.0), shinyWidgets, shinyalert,
        data.table (>= 1.12.8), DT (>= 0.11), stringr, plyr, dplyr,
        purrr, stats, patchwork, ggparty, GGally
RoxygenNote: 7.3.2
Suggests: testthat (>= 2.1.0), shinytest, devtools, ranger, e1071,
        xgboost, igraph, readxl, DALEX, DALEXtra, bslib, haven
NeedsCompilation: no
Packaged: 2024-12-28 13:04:27 UTC; laurensmartintetzlaff
Author: Laurens Tetzlaff [aut, cre],
  Gero Szepannek [aut],
  Alexander Frahm [aut],
  Dominic Henning [aut],
  Jakob Steinbrink [aut]
Maintainer: Laurens Tetzlaff <laurens.tetzlaff@outlook.de>
Repository: CRAN
Date/Publication: 2025-01-09 13:50:02 UTC
Built: R 4.6.0; ; 2026-04-30 13:52:01 UTC; unix

# mlr3shiny: Machine Learning in Shiny with mlr3 <img src="man/figures/logo.png" align="right" width = "120" />

[![Build Status](https://app.travis-ci.com/LamaTe/mlr3shiny.svg?branch=master)](https://app.travis-ci.com/github/LamaTe/mlr3shiny)

This application provides the basic steps of a machine learning workflow from a graphical user interface built with Shiny. It uses the functionalities of the R-package [mlr3](https://mlr3.mlr-org.com).

Current functionalities of mlr3shiny are:
* Data import
* Creation of a task for supervised learning (regression, classification)
* Use of a set of algorithms as learners
* Training and evaluation of the generated models
* Benchmarking to compare several learners on a task simultaneously
* Prediction on new data using the trained learner
* Explain trained learner 

## Reference

Tetzlaff, L. and Szepannek G. (2022): mlr3shiny—State-of-the-art machine learning made easy, SoftwareX 20, DOI: 
[10.1016/j.softx.2022.101246](https://doi.org/10.1016/j.softx.2022.101246).

## Installation

Install the package in R via CRAN:

``` r
install.packages(mlr3shiny)
```

Install the development version of the package in R from GitHub.
``` r
remotes::install_github("https://github.com/LamaTe/mlr3shiny.git")
```

## Example
Launch the application via:
``` r
mlr3shiny::launchMlr3Shiny()
```

## Usage Description
Navigate over the different steps of the workflow using the menu bar. The tabs are chronologically ordered. 
The question mark in the top-right corner provides more information on the functionalities and purpose of each section.
Start by importing a dataset. Then define a task (the problem to be solved) in the 'task' tab. Example tasks are already provided. Select different learners (algorithms) in the 'learner' tab and train and evaluate a model in 'train & evaluate'. 
Resampling strategies can be applied in a sub-section of 'train & evaluate'.
Alternatively, different learners can be compared in a benchmark.
Use the final model to make a prediction on new data in the 'predict' tab. 
An explanation of the final model from the predict tab can be made in the 'explain' tab. 

## References to Algorithms
* [linear/ logistic regression](https://stat.ethz.ch/R-manual/R-devel/library/stats/html/00Index.html)
* [decision tree](https://CRAN.R-project.org/package=rpart)
* [random forest](https://CRAN.R-project.org/package=ranger)
* [support vector machine](https://CRAN.R-project.org/package=e1071)
* [xgboost](https://CRAN.R-project.org/package=xgboost)

### Basic Workflow reactive values
Help <- reactiveValues(Tracker = 1)
Wf <- reactiveValues(Current_Learner = NULL, Overview = NULL, State = NULL, TrainIds = NULL, TestIds = NULL,
                     Pred_Test = NULL, Pred_Train = NULL, Perf_Test = NULL, Perf_Train = NULL)
## Functions
#get Learner choices
getLearnChoicesUI <- function() {
  if (is.null(LearnerMeta$Learner_Avail)) {
    ui <- tagList(
      column(12,
             h5("No learner has been created yet in step 3.")
      )
    )
    return(ui)
  }
  else {
    ui <- tagList(
        column(6,
               radioButtons(inputId = "TrainFit_learner", label = h5("Select a new learner:"), choices = LearnerMeta$Learner_Avail,
                            selected = character(0))
        )
      )
    return(ui)
  }
}
# get Basic Workflow data
getWfPerfTest <- function() {
  if (is.null(Wf$Perf_Test)) {
    return("[not scored]")
  }
  else {
    wfPerf <- character(0)
    for (i in names(Wf$Perf_Test)) {
      wfPerf <- paste(c(wfPerf, paste(i, round(Wf$Perf_Test[[i]], 3), sep = ": ")), collapse = ", ")
    }
    return(wfPerf)
  }
}

getWfPerfTrain <- function() {
  if (is.null(Wf$Perf_Train)) {
    return("[not scored]")
  }
  else {
    wfPerf <- character(0)
    for (i in names(Wf$Perf_Train)) {
      wfPerf <- paste(c(wfPerf, paste(i, round(Wf$Perf_Train[[i]], 3), sep = ": ")), collapse = ", ")
    }
    return(wfPerf)
  }
}

getLrnModel <- function() {
  if (is.null(Wf$Current_Learner$model)) {
    return("[missing]")
  }
  else {
    # cutting down model names like "colapply.encode.classif.svm.threshold" to "classif.svm"
    # by iterating over LearnerMeta$learner_choice and using this model name 
    for (learner in LearnerMeta$learner_choice) {
      if (grepl(learner, Wf$Current_Learner$id)) {
        return(learner)
      }
    }
  }
}

getWfState <- function() {
  if (is.null(Wf$Current_Learner$model)) {
    Wf$State <- "defined"
  }
  else if (is.null(Wf$Pred_Test)) {
    Wf$State <- "trained"
  }
  else if (is.null(Wf$Perf_Test)) {
    Wf$State <- "predicted"
  }
  return(Wf$State)
}

createWfOverview <- function() {
  overview <- list(
    Task <- currenttask$task$id,
    Learner <- Wf$Current_Learner$label,
    "State of Workflow" <- getWfState(),
    Model <- getLrnModel(),
    "Performance Train Data" <- getWfPerfTrain(),
    "Performance Test Data" <- getWfPerfTest()
  )
  return(overview)
}

# create Basic Workflow overview ui
addOverviewLineWf = function(title, body) {
  fluidRow(
    column(6, h5(title)),
    column(6, h5(body))
  )
}

getWfOverviewUi <- function() {
  if (is.null(Wf$Current_Learner)) {
    return(h5("The basic workflow has not been started yet. Please define a learner in step 3 and select it."))
  }
  else {
    overviewUi <- tagList(
      fluidRow(
        column(12,
               h5("Basic Workflow Overview", style = "font-weight: bold;"),
               addOverviewLineWf("Task: ", Wf$Overview[[1]]),
               addOverviewLineWf("Learner: ", Wf$Overview[[2]]),
               addOverviewLineWf("State of Workflow: ", Wf$Overview[[3]]),
               addOverviewLineWf("Model: ", Wf$Overview[[4]]),
               addOverviewLineWf("Performance Training Set: ", Wf$Overview[[5]]),
               addOverviewLineWf("Performance Test Set: ", Wf$Overview[[6]])
        )
      )
    )
    return(overviewUi)
  }
}


# validate and train model
trainModel <- function(inputsplit, inputseed) {
  withProgress(message = "Training model", {
    set.seed(inputseed)
    Wf$TrainIds <- sample(currenttask$task$row_ids, currenttask$task$nrow * (inputsplit / 100))
    Wf$TestIds <- setdiff(currenttask$task$row_ids, Wf$TrainIds)
    incProgress(0.3)
    withCallingHandlers(
      tryCatch({
          Wf$Current_Learner$train(task = currenttask$task, row_ids = Wf$TrainIds)
        },
        error = errorAlertTrain
      )
    )
    incProgress(0.5)
    Wf$Overview <- createWfOverview()
    #toggle(id = "TrainPred_model_download", condition = (!is.null(Exp$Model)))
  })
}

validateSplit <- function(inputsplit, inputseed) {
  if (inputsplit == 0 || inputsplit == 100) {
    shinyalert(title = "Invalid Parameter Input",
               text = paste("The data split that you want to perform is not supported.",
                            "If you want to train your model on the entire training dataset, please got to the 'predict'-tab, instead.",
                            sep = " "),
               animation = FALSE, closeOnClickOutside = TRUE)
  }
  else {
    trainModel(inputseed = inputseed, inputsplit = inputsplit)
  }
}

# create Train model ui
getTrainUi <- function() {
  if (is.null(Wf$Current_Learner)) {
    return(h5("No learner has been selected yet."))
  }
  else {
    trainui <- tagList(
      fluidRow(
        column(12,
               h5(paste("Select percentage of training data for model training and evaluation.",
                        "Set a seed to reproduce the random partitioning anytime.",
                        "The default value to start sampling the training data from is 42.", sep = " "))
        )
      ),
      fluidRow(
        column(3, numericInput(inputId = "TrainFit_seed", label = NULL, value = 42)
        ),
        column(9, sliderInput(inputId = "TrainFit_input_split", label = NULL, min = 0, max = 100, value = 80)
        )
      ),
      fluidRow(
        column(12,
               actionButton(inputId = "TrainFit_train_model", label = "Train model", style = "float: left;")
        )
      )
    )
    return(trainui)
  }
}

# create predict target ui
getPredictUi <- function(Wfstate) {
  if (is.null(Wfstate) || Wfstate == "defined") {
    return(h5("The learner model has not been trained yet."))
  }
  else {
    predictui <- tagList(
      fluidRow(
        column(12,
               h5(paste("Use the trained model to predict the target values on the remaining test data of the training-test split",
                        "as well as on the data partition the model was trained on.", sep = " "))
        )
      ),
      fluidRow(
        column(12,
               actionButton(inputId = "TrainFit_predict_data", label = "Predict target", style = "float: left;")
        )
      )
    )
    return(predictui)
  }
}

# create score ui
getScoreUi <- function(Wfstate){
  if (is.null(Wfstate) || Wfstate == "defined" || Wfstate == "trained") {
    return(h5("A prediction has not been computed yet."))
  }
  else {
    scoreui <- tagList(
      fluidRow(
        column(6,
               selectizeInput(inputId = "TrainFit_select_measure", label = NULL,
                              choices = get_msrs(currenttask$task, Wf$Current_Learner, avail_msrs, msr_translations),
                              # options = list(
                              #   placeholder = 'Nothing selected',
                              #   onInitialize = I('function() { this.setValue(""); }')
                              # ),
                              selected = get_msrs(currenttask$task, Wf$Current_Learner, avail_msrs, msr_translations)[1],
                              multiple = TRUE)
        ),
        column(6,
               actionButton(inputId = "TrainFit_score_perf", label = "Score", style = "float: right;")
        )
      )
    )
    return(scoreui)
  }
}

getPredTable <- function(currentpred) {
  if (!is.null(currentpred)) {
    tabl <- DT::datatable(as.data.table(currentpred),
                          options = list(scrollX = TRUE, searching = FALSE, bInfo = FALSE, lengthChange = FALSE))
    return(tabl)
  }
}

# reset Workflow
resetWf <- function() {
  Wf$Current_Learner <- NULL
  Wf$TrainIds <- NULL
  Wf$ValidIds <- NULL
  Wf$Pred_Test <- NULL
  Wf$Pred_Train <- NULL
  Wf$Perf_Test <- NULL
  Wf$Perf_Train <- NULL
  Wf$State <- NULL
}
##


## Observers
# select Learner when available
output$TrainFit_learner_selection <- renderUI({
  getLearnChoicesUI()
})

# Create and update Workflow Overview
output$TrainFit_overview <- renderUI({
  getWfOverviewUi()
})


# show train model ui
output$TrainFit_train <- renderUI({
  getTrainUi()
})

# ensure data split is adequate
observeEvent(input$TrainFit_train_model, {
  validateSplit(inputsplit = input$TrainFit_input_split, inputseed = input$TrainFit_seed)
})



# show predict target ui
output$TrainFit_predict <- renderUI({
  getPredictUi(getWfState())
})

# predict target
observeEvent(input$TrainFit_predict_data, {
  withCallingHandlers(
    tryCatch({
      Wf$Pred_Train <- Wf$Current_Learner$predict(task = currenttask$task, row_ids = Wf$TrainIds)
      Wf$Pred_Test <- Wf$Current_Learner$predict(task = currenttask$task, row_ids = Wf$TestIds)
      },
      error = errorAlertPredict
    ),
    warning = warningAlert
  )
  Wf$Overview <- createWfOverview()
})

# show Train/Test prediction tables
output$TrainFit_pred_view_test <- DT::renderDataTable({
  getPredTable(Wf$Pred_Test)
})

output$TrainFit_pred_view_train <- DT::renderDataTable({
  getPredTable(Wf$Pred_Train)
})

# show prediction data tables
observe({
  toggle(id = "TrainFit_well_test", condition = !is.null(Wf$Pred_Test))
  toggle(id = "TrainFit_well_train", condition = !is.null(Wf$Pred_Train))
})



# show Score ui
output$TrainFit_score <- renderUI({
  getScoreUi(Wfstate = getWfState())
})
# compute and show scored train/test performance
observeEvent(input$TrainFit_score_perf, {
  measures <- msrs(c(input$TrainFit_select_measure))
  Wf$Perf_Train <- Wf$Pred_Train$score(measures)
  Wf$Perf_Test <- Wf$Pred_Test$score(measures)
  Wf$Overview <- createWfOverview()
})



# set current learner
observeEvent(input$TrainFit_learner, {
  resetWf()
  Wf$Current_Learner <- get(input$TrainFit_learner)$Learner$clone(deep = TRUE)
  Wf$Overview <- createWfOverview()
})

# reset Workflow when task changes
observeEvent(currenttask$task, {
  resetWf()

})

### Use Resampling
observeEvent(input$TrainFit_resample, {
  toggle(id = "TrainFit_Basic")
  toggle(id = "TrainFit_Resample")
  Help$Tracker <- 2
})

observeEvent(input$TrainFit_Base, {
  toggle(id = "TrainFit_Resample")
  toggle(id = "TrainFit_Basic")
  Help$Tracker <- 1
})

# Layout of "Train and Evaluate" UI
tabpanel_TrainFit <- fluidPage(
  fluidRow(
    id = "TrainFit_Basic",
    column(4,
           wellPanel(
                fluidRow(
                  column(6,
                         h5("Basic Workflow", style = "font-weight: bold;")
                         ),
                  column(6,
                         actionButton(inputId = "TrainFit_resample", label = "Use Resampling")
                  )
                  ),
                  hr(style = "border-color: #3e3f3a;"),
                  fluidRow(
                           uiOutput(outputId = "TrainFit_learner_selection")
                  ),
                  hr(style = "border-color: #3e3f3a;"),
                  fluidRow(
                    column(12,
                           uiOutput(outputId = "TrainFit_overview")
                           )
                  )

                )

           ),
    column(4,
           wellPanel(
             h5("Train Model", style = "font-weight: bold;"),
             uiOutput(outputId = "TrainFit_train")
             ),
           wellPanel(
             h5("Predict Target Variable", style = "font-weight: bold;"),
             uiOutput(outputId = "TrainFit_predict")
             ),
           wellPanel(
             h5("Measure Prediction Performance", style = "font-weight: bold;"),
             uiOutput(outputId = "TrainFit_score")
           )
    ),
    column(4,
           hidden(
             wellPanel(
               id = "TrainFit_well_test",
               h5("Predicted Target on Test Data", style = "font-weight: bold;"),
               DT::dataTableOutput(outputId = "TrainFit_pred_view_test")
               )
           ),
           hidden(
             wellPanel(
               id = "TrainFit_well_train",
               h5("Predicted Target on Training Data", style = "font-weight: bold;"),
               DT::dataTableOutput(outputId = "TrainFit_pred_view_train")
               )
           )
    )
  ),
  hidden(resample_ui)
)

# reactive values for resampling
Res <- reactiveValues(Current_Learner = NULL, Strat = NULL, R_Res = NULL, Perf_Aggr = NULL, Overview = NULL)

## Functions
# get Resampling Workflow data
getResPerfAggr <- function() {
  if (is.null(Res$Perf_Aggr)) {
    return("[not available]")
  }
  else {
    resPerf <- character(0)
    for (i in names(Res$Perf_Aggr)) {
     resPerf <- paste(c(resPerf, paste(i, round(Res$Perf_Aggr[[i]], 3), sep = ": ")), collapse = ", ")
    }
    return(resPerf)
  }
}

getResIters <- function() {
  if (is.null(Res$R_Res)) {
    return("[not available]")
  }
  else {
    return(Res$Strat$iters)
  }
}

createResOverview <- function() {
  overview <- list(
    Task <- currenttask$task$id,
    Learner <- Res$Current_Learner$label,
    Strategy <- input$Res_strategy,
    Iterations <- getResIters(),
    "Aggregated Performance" <- getResPerfAggr()
  )
  return(overview)
}

getResOverviewUi <- function() {
  if (!is.null(Res$Current_Learner)) {
    overviewUi <- tagList(
      hr(style = "border-color: #3e3f3a;"),
      fluidRow(
        column(12,
               h5("Resampling Overview", style = "font-weight: bold;"),
               addOverviewLineWf("Task: ", Res$Overview[[1]]),
               addOverviewLineWf("Learner: ", Res$Overview[[2]]),
               addOverviewLineWf("Resampling Strategy: ", Res$Overview[[3]]),
               addOverviewLineWf("Performed Iterations: ", Res$Overview[[4]]),
               addOverviewLineWf("Aggregated Performance: ", Res$Overview[[5]])
        )
      )
    )
    return(overviewUi)
  }
}

# get resampling parameter ui
stratify <- function(id, default) {
  stratifyui <- tagList(
    column(12,
           checkboxInput(inputId = paste0(id, "_stratify"), label = "Stratification", value = default)
           )
  )
  return(stratifyui)
}

ratio <- function(id, default) {
  ratioui <- tagList(
    column(6,
           numericInput(inputId = paste0(id, "_ratio"), label = h5("Fraction in (0, 1) of the data used for training the model"), value = default, min = 0, max = 1, step = 0.1)
           )
  )
  return(ratioui)
}

folds <- function(id, default) {
  foldsui <- tagList(
    column(6,
           numericInput(inputId = paste0(id, "_folds"), label = h5("Iterations"), value = default, min = 1)
    )
  )
  return(foldsui)
}

repeats <- function(id, default) {
  repeatsui <- tagList(
    column(6,
           numericInput(inputId = paste0(id, "_repeats"), label = h5("Repetitions"), value = default, min = 1)
           )
  )
  return(repeatsui)
}

# get available parameter per learner for resampling
getResParams <- function() {
  if (is.null(Res$Current_Learner)) {
    return(column(12,
                  h5("No learner has been selected yet.")
                  )
    )
  }
  else {
    params <- tagList()
    for (i in rev(Res$Strat$param_set$ids())) {
        params <- tagAppendChild(params, get(i)(id = "Res", default = Res$Strat$param_set$values[[i]]))
    }
    return(params)
  }
}

# get Learner and resampling choices
getLearnResChoicesUI <- function() {
  if (is.null(LearnerMeta$Learner_Avail)) {
    ui <- tagList(
      column(12,
             h5("No learner has been created yet.")
      )
    )
    return(ui)
  }
  else {
    ui <- tagList(
      column(6,
             radioButtons(inputId = "Res_learner", label = h5("Select a new learner:"), choices = LearnerMeta$Learner_Avail,
                          selected = character(0))
      ),
      column(6,
             radioButtons(inputId = "Res_strategy", label = h5("Select a resampling strategy:"),
                          choices = c("holdout", "cross-validation" = "cv", "bootstrap"))
      )
    )
    return(ui)
  }
}

# get available measures
getResMeasuresUi <- function() {
  if (!is.null(Res$R_Res)) {
  measureui <- tagList(
    hr(style = "border-color: #3e3f3a;"),
    h5("Measure Aggregated Performance", style = "font-weight: bold;"),
    fluidRow(
      column(6,
             selectizeInput(inputId = "Res_measures", label = NULL,
                            choices = get_msrs(currenttask$task, Res$Current_Learner, avail_msrs, msr_translations),
                            # options = list(
                            #   placeholder = 'Nothing selected',
                            #   onInitialize = I('function() { this.setValue(""); }')
                            # ),
                            selected = get_msrs(currenttask$task, Wf$Current_Learner, avail_msrs, msr_translations)[1],
                            multiple = TRUE)
      ),
      column(6,
             actionButton(inputId = "Res_aggr_measure", label = "Score", style = "float: right;")
      )
    )
  )
  return(measureui)
  }
}

getResButton <- function() {
  if (!is.null(Res$Current_Learner)) {
    buttonui <- tagList(
      hr(style = "border-color: #3e3f3a;"),
      fluidRow(
        column(12,
               div(style = "display:inline-block; width:100%; text-align: center;",
                   actionButton(inputId = "Res_resample", label = "Perform Resampling"),
                   h5("Resampling large datasets may take a while.")
               )
        )
      )
    )
    return(buttonui)
  }
}

getResTable <- function() {
  if (!is.null(Res$R_Res)) {
    ui <- DT::datatable(as.data.table(Res$R_Res$prediction()),
                options = list(scrollX = TRUE,searching = FALSE, bInfo = FALSE, lengthChange = FALSE))
  }
  else {
    ui <- NULL
  }
  return(ui)
}

getResDownload <- function() {
  if (!is.null(Res$R_Res)) {
    downloadbtnui <- tagList(
      hr(style = "border-color: #3e3f3a;"),
        div(style = "display:inline-block; width:100%; text-align: center;",
            #hidden(
              downloadButton(outputId  = "Res_result_download", label = "Export Resampling Result")
             # )
        )
    )
  }
}

## outputs and observers
# make Learner and resampling choices ui
output$Res_learner_selection <- renderUI({
    getLearnResChoicesUI()
})

output$Res_overview <- renderUI({
  getResOverviewUi()
})

# set resampling strategy
observeEvent(input$Res_strategy, {
  Res$R_Res <- NULL
  Res$Perf_Aggr <- NULL
  Res$Strat <- rsmp(input$Res_strategy)
  Res$Overview <- createResOverview()
})

# make params ui
output$Res_params <- renderUI({
    getResParams()
})

# make measure and resample button ui
output$Res_measure <- renderUI({
    getResMeasuresUi()
})

output$Res_resample_button <- renderUI({
    getResButton()
})

# set hyperparams for strategy and perform resampling
observeEvent(input$Res_resample, {
  paramsres <- list()
  for (i in Res$Strat$param_set$ids()) {
    paramsres[[i]] <- input[[paste0("Res_", i)]]
  }

  withProgress(message = "Performing resampling strategy",
    withCallingHandlers(
      tryCatch({Res$Strat$param_set$values <- paramsres
      set.seed(42)
      incProgress(0.2)
      Res$R_Res <- resample(task = currenttask$task, learner = Res$Current_Learner, resampling = Res$Strat)
      incProgress(0.5)
      },
      error = errorAlertResample
      ),
      warning = warningAlert
    )
  )
  Res$Overview <- createResOverview()
})

observeEvent(input$Res_aggr_measure, {
  withCallingHandlers(
    tryCatch(Res$Perf_Aggr <- Res$R_Res$aggregate(msrs(c(input$Res_measures))),
             error = errorAlertResample),
    warning = warningAlert
  )
  Res$Overview <- createResOverview()
})



output$Res_pred_view <- DT::renderDataTable({
  getResTable()
})
observe({
  toggle(id = "Res_well_prediction", condition = !is.null(Res$R_Res))
})

output$Res_download <- renderUI({
  getResDownload()
})

output$Res_result_download <- downloadHandler(
  filename = function() {
    paste(paste("ResamplingResult", Res$Strat$id, Res$Current_Learner$id, sep = "_"), ".rds", sep = "")
  },
  content = function(file) {
    saveRDS(Res$R_Res, file = file)
  }
)

# start or reset resampling workflow
# set current learner
resetRes <- function() {
  Res$Current_Learner = NULL
  Res$R_Res = NULL
  Res$Perf_Aggr = NULL
  Res$Overview = NULL
  #Res$Strat = NULL
}

observeEvent(input$Res_learner, {
  resetRes()
  Res$Current_Learner <- get(input$Res_learner)$Learner$clone(deep = TRUE)
  Res$Overview <- createResOverview()
})

observeEvent(currenttask$task, {
  resetRes()
})

# Layout of "Learner" UI
tabpanel_Learner <- fluidPage(
    fluidRow(
      column(4,
             wellPanel(
               h5("Select a machine-learning algorithm", style = "font-weight: bold;"),
               hr(style = "border-color: #3e3f3a;"),
               fluidRow(
                 column(12,
                        fluidRow(
                          column(12,
                                 uiOutput(outputId = "Learner_other_Learner1")
                                 )
                          ),
                        fluidRow(
                          column(12,
                                 uiOutput(outputId = "Learner_other_Learner2")
                                 )
                          ),
                        fluidRow(
                          column(12,
                                 uiOutput(outputId = "Learner_other_Learner3")
                          )
                        ),
                        fluidRow(
                          column(12,
                                 uiOutput(outputId = "Learner_other_Learner4")
                          )
                        ),
                        fluidRow(
                          column(12,
                                 uiOutput(outputId = "Learner_other_Learner5")
                          )
                        ),
                        fluidRow(
                          column(12,
                                 uiOutput(outputId = "Learner_other_Learner6")
                          )
                        ),
                        fluidRow(
                          column(12,
                                 uiOutput(outputId = "Learner_other_Learner7")
                          )
                        ),
                        HTML("<br/>"),
                        fluidRow(
                          column(12,
                                 div(style = "display:inline-block; width:100%; text-align: center;",
                                     actionButton(inputId = "Learner_add", label = " Add Learner", icon = icon("plus")))
                          )
                        )
                 )
               )
             )
      ),
     column(8,
                   id = "Learner_NA",
                   wellPanel(h4("No Learner has been created yet.",
                                style = "text-align: center; text-weight: bold;"))
     ),
     hidden(
       mainPanel(
         id = "Learner_Learners",
         tabsetPanel(
           id = "Learner_Learners_Tab",
           tabPanel(title = "Learner 1",
                    uiOutput(outputId = "Learner1_ov"),
                    uiOutput(outputId = "Learner1_tab")
           ),
           tabPanel(title = "Learner 2",
                    uiOutput(outputId = "Learner2_ov"),
                    uiOutput(outputId = "Learner2_tab")),
           tabPanel(title = "Learner 3",
                    uiOutput(outputId = "Learner3_ov"),
                    uiOutput(outputId = "Learner3_tab")),
           tabPanel(title = "Learner 4",
                    uiOutput(outputId = "Learner4_ov"),
                    uiOutput(outputId = "Learner4_tab")),
           tabPanel(title = "Learner 5",
                    uiOutput(outputId = "Learner5_ov"),
                    uiOutput(outputId = "Learner5_tab")),
           tabPanel(title = "Learner 6",
                    uiOutput(outputId = "Learner6_ov"),
                    uiOutput(outputId = "Learner6_tab")),
           tabPanel(title = "Learner 7",
                    uiOutput(outputId = "Learner7_ov"),
                    uiOutput(outputId = "Learner7_tab"))
           )
         )
       )
     )
  )

# Layout of "Predict" UI
tabpanel_predict <- fluidPage(
  fluidRow(
    column(3,
           wellPanel(
             h5("Apply best learner on new data", style = "font-weight: bold;"),
             hr(style = "border-color: #3e3f3a;"),
             uiOutput(outputId = "Predict_learner_choice"),
             uiOutput(outputId = "Predict_learner_overview"),
             uiOutput(outputId = "Predict_learner_train_btn"),
             uiOutput(outputId = "Predict_learner_download_btn"),
             uiOutput(outputId = "Predict_codegen_btn")
           )
           ),
    column(3,
           wellPanel(
             h5("Import a new dataset", style = "font-weight: bold;"),
             hr(style = "border-color: #3e3f3a;"),
             selectInput(
               inputId = "Predict_data_type", label = h5("Type"),choices = c("csv", "txt", "xlsx","spss","sas","stata"),
               selected = "csv"),
             # To be expanded, if more file formats are accepted
             conditionalPanel(
               condition = "input.Predict_data_type == 'csv' || input.Predict_data_type == 'txt'",
               fileInput(inputId = "Predict_data_csv", label = h5("Select a File"),
                         accept = c("text/csv", ".csv", "text/comma-separated-values,text/plain", "text*")),
               checkboxInput("Predict_data_header", "Header", TRUE),
               selectInput(inputId = "Predict_data_sep", label = h5("Separator"),
                           choices = c(Comma = ",", Semicolon = ";", Tab = "\t", Space = " ", Vertical = "|")),
               selectInput(inputId = "Predict_data_quote", label = h5("Quote"),
                           choices = c(None = "", "Double Quote" = '"', "Single Quote" = "'"), selected = '"')
             ),
             conditionalPanel(
               condition = "input.Predict_data_type == 'xlsx' || input.Predict_data_type == 'xls'",
               fileInput(inputId = "Predict_data_xlsx", label = h5("Select a File"),
                         accept = c(".xlsx", ".xls")),
               checkboxInput("Predict_data_header_xlsx", "Header", TRUE),
               numericInput(inputId = "Predict_data_sheet", label = h5("Sheet"), value = 1)
             ),
             conditionalPanel(
               condition = "input.Predict_data_type == 'spss'",
               fileInput(
                 inputId = "Predict_data_spss", label = h5("Select a File"),
                 accept = c(".sav", ".por")
               )
             ),
             conditionalPanel(
               condition = "input.Predict_data_type == 'sas'",
               fileInput(
                 inputId = "Predict_data_sas", label = h5("Select a File"),
                 accept = c(".sas7bdat")
               )
             ),
             conditionalPanel(
               condition = "input.Predict_data_type == 'stata'",
               fileInput(
                 inputId = "Predict_data_stata", label = h5("Select a File"),
                 accept = c(".dta")
               )
             ),
             hr(style = "border-color: #3e3f3a;"),
             div(style = "display:inline-block; width:100%; text-align: center;",
                 actionButton(inputId = "Predict_predict", label = "Predict target", icon = icon("search"))
             )
           )
           ),
    column(6,
           hidden(
             wellPanel(
               id = "Pred_well_new_data",
               h5("New dataset", style = "font-weight: bold;"),
               DT::dataTableOutput(outputId = "Pred_new_data_view")
             )
           ),
           hidden(
             wellPanel(
               id = "Pred_well_prediction",
               h5("Prediction", style = "font-weight: bold;"),
               DT::dataTableOutput(outputId = "Pred_prediction_view"),
               fluidRow(
                 column(12,
                        downloadButton(outputId  = "Pred_prediction_download_csv", label = "Export as .csv", style = "float: left;"),
                        downloadButton(outputId  = "Pred_prediction_download_rds", label = "Export as .rds", style = "float: right;")
                        )
                 )
               )
             ),
             hidden(
              wellPanel(
              id = "Pred_well_decision_tree",
              fluidRow(
                column(4, h5("Decision Tree", style="font-weight: bold;")),
                column(4, actionButton(inputId = "action_visualize_predict", label = "Visualize Tree", icon = icon("hammer")))),
              uiOutput(outputId = "plotDecisionTree")
              )
             )
    )
  )
)

ui_files <- list.files(path = "./ui")
ui_files <- paste0("ui/", ui_files)

for (i in seq_along(ui_files)) {
  source(ui_files[i], local = TRUE)
}

ui <- tagList(
  tags$head(
    tags$style(
      HTML(
        ".well {box-shadow: 0 2px 3px 0
            rgba(90,97,105,.11), 0 4px 8px 0
            rgba(90,97,105,.12),0 15px 22px 0
            rgba(90,97,105,.1),0 7px 35px 0
            rgba(90,97,105,.1) !important;
            background-color: #fff !important;}
          ",
        ".navbar {background-color: #2FA4E7;}",
        ".navbar-default .navbar-nav>.active>a, .navbar-default .navbar-nav>.active>a:focus, .navbar-default .navbar-nav>.active>a:hover
        {background-color:}",
        "h5 {color: black;}",
        ".alert-info {
          background-color: #2FA4E7 !important;
          p {color: white !important}
          button {color: #575757 !important}}",
        ".alert-warning {
          background-color: #d97070 !important;
          p {color: white !important}
          button {color: #575757 !important}}"
      )
    )
  ),
  useShinyjs(),
  circleButton(
    inputId = "Help", icon = icon("question"),
    status = "white", size = "sm", style = "position:absolute; right:2em; top:0.35em; z-index:1001; color: #2FA4E7;"
  ),
  navbarPage(
    theme =  bs_theme(version = 3, bootswatch = 'cerulean'),
    title = a("mlr3shiny", href = "https://github.com/LamaTe/mlr3shiny", target = "_blank", style = "color: white;"),
    windowTitle = "mlr3shiny",
    id = "navbar",
    tabPanel("1. Data",
      tabpanel_Data,
      icon = icon("database"),
      id = 'data'
    ),
    tabPanel("2. Task",
      tabpanel_Task,
      icon = icon("bookmark"),
      id = 'task'
    ),
    tabPanel("3. Learner",
      tabpanel_Learner,
      icon = icon("filter"),
      id = 'learner'
    ),
    tabPanel("4. Train & Evaluate",
      tabpanel_TrainFit,
      icon = icon("cogs"),
      id = 'train'
    ),
    tabPanel("5. Benchmarking",
      tabpanel_benchmarking,
      icon = icon("chart-bar"),
      id = 'benchmark'
    ),
    tabPanel("6. Predict",
      tabpanel_predict,
      icon = icon("search"),
      id = 'predict'
    ),
    tabPanel("7. Explain",
    tabpanel_evaluating,
    icon = icon("chalkboard-teacher")
    )
  )
)

# Layout of  "Import" tab
tabpanel_Data <- fluidPage(
  sidebarLayout(
    sidebarPanel(
      id = "data_panel",  # just an id for shinytest
      width = 3,
      # import training data
      helpText("Welcome to mlr3shiny!", style = "text-align: center;"),
      helpText("Get to know machine learning in R with mlr3 and the help of Shiny.", HTML("<br/>"),
               "For more information click on the questionmark in the top-right corner or visit the GitHub repository by clicking on 'mlr3shiny'.
                To get started import a data set.",
               style = "text-align: center;"),
      hr(style = "border-color: #3e3f3a;"),
      h5("Import training data", style = "font-weight: bold;"),
      selectInput(
        inputId = "Data_train_type", label = h5("Type"), choices = c("csv", "txt", "xlsx","spss","sas","stata"),
        selected = "csv"
      ),
      # To be expanded, if more file formats are accepted
      conditionalPanel(
        condition = "input.Data_train_type == 'csv' || input.Data_train_type == 'txt'",
        fileInput(
          inputId = "Data_train_csv", label = h5("Select a File"),
          accept = c("text/csv", ".csv", "text/comma-separated-values,text/plain", "text*")
        ),
        checkboxInput("Data_train_header", "Header", TRUE),
        selectInput(
          inputId = "Data_train_sep", label = h5("Separator"),
          choices = c(Comma = ",", Semicolon = ";", Tab = "\t", Space = " ", Vertical = "|"),
          selected = ","
        ),
        selectInput(
          inputId = "Data_train_quote", label = h5("Quote"),
          choices = c(None = "", "Double Quote" = '"', "Single Quote" = "'"), selected = '"'
        )
      ),
      conditionalPanel(
        condition = "input.Data_train_type == 'xlsx' || input.Data_train_type == 'xls'",
        fileInput(
          inputId = "Data_train_xlsx", label = h5("Select a File"),
          accept = c(".xlsx", ".xls")
        ),
        checkboxInput("Data_train_header_xlsx", "Header", TRUE),
        numericInput(inputId = "Data_train_sheet", label = h5("Sheet"), value = 1)
      ),
      conditionalPanel(
        condition = "input.Data_train_type == 'spss'",
        fileInput(
          inputId = "Data_train_spss", label = h5("Select a File"),
          accept = c(".sav", ".por")
        )
      ),
      conditionalPanel(
        condition = "input.Data_train_type == 'sas'",
        fileInput(
          inputId = "Data_train_sas", label = h5("Select a File"),
          accept = c(".sas7bdat")
        )
      ),
      conditionalPanel(
        condition = "input.Data_train_type == 'stata'",
        fileInput(
          inputId = "Data_train_stata", label = h5("Select a File"),
          accept = c(".dta")
        )
      )
    ),
    mainPanel(
      width = 9,
      DT::dataTableOutput(outputId = "Data_train_view")
    )
  )
)

tabpanel_evaluating <- fluidRow(
    column(
        3,
        wellPanel(
            uiOutput(outputId = "eval_learner_selection"),
            
            fluidRow(
              column(
                12,
                uiOutput(outputId = "eval_explanation_selection")
              )
            ),
            
            fluidRow(
                column(
                    12,
                    uiOutput(outputId = "eval_loss_function_selection")
                )
            ),
            fluidRow(
                column(
                    12,
                    uiOutput(outputId = "eval_compare_method_selection")
                )
            ),
            fluidRow(
              column(
                12,
                uiOutput(outputId = "eval_analysis_plot_selection")
              )
            ),
            fluidRow(
              column(
                12,
                uiOutput(outputId = "eval_analysis_automation")
              )
            ),
              fluidRow(
                id = "automation_slider",
                column(
                  12,
                  uiOutput(outputId = "eval_automation_slider")
                )
              ),
            hidden(
                fluidRow(
                    id = "feature_selection_panel",
                    column(
                        12,
                        uiOutput(outputId = "eval_learner_feat_selection")
                    )
                )
            ),
            fluidRow(
                id = "evaluate_start_button",
                column(
                    12,
                    div(
                        style = "display:inline-block; width:100%; text-align: center;",
                        actionButton(inputId = "evaluate_start", label = "Start evaluating")
                    )
                )
            )
        )
    ),
    column(
        9,
        uiOutput(outputId = "eval_learner_plot_tabs")
    )
)

# generate data.table when a fitting file is uploaded
data <- reactiveValues(traindata = NULL)

### TO-DO make sure that missings are loaded as na to be counted correctly later on

# training data
observe({
  if (input$Data_train_type == "csv" || input$Data_train_type == "txt") {
     filepath <-  input$Data_train_csv$datapath
     if (!is.null(filepath) && (str_sub(filepath, -4, -1) == ".csv" || (str_sub(filepath, -4, -1) == ".txt" ))) {
       data$traindata <- read.csv(file = filepath, header = input$Data_train_header,
                               sep = input$Data_train_sep, quote = input$Data_train_quote, stringsAsFactors = TRUE)
     }
  } else if (input$Data_train_type == "xlsx") {
      filepath <-  input$Data_train_xlsx$datapath
        if (!is.null(filepath) && (str_sub(filepath, -5, -1) == ".xlsx")) {
         traintibble <- read_excel(path = filepath, col_names = input$Data_train_header_xlsx,
                                         sheet = input$Data_train_sheet)
         traindf <- as.data.frame(traintibble)
         data$traindata <- modify_at(traindf,
                                     which(as.character(sapply(traindf, class)) == "character"),
                                     as.factor)
        }
  } else if (input$Data_train_type == "spss") {
    filepath <-  input$Data_train_spss$datapath
    if (!is.null(filepath) && (str_sub(filepath, -4, -1) == ".sav" | str_sub(filepath, -4, -1) == ".por") ) {
      traintibble <- read_spss(file = filepath)
      traindf <- as.data.frame(traintibble)
      traindf <- as_factor(traindf)
      data$traindata <- modify_at(traindf,
                                  which(as.character(sapply(traindf, class)) == "character"),
                                  as.factor)
    }
  } else if (input$Data_train_type == "sas") {
    filepath <-  input$Data_train_sas$datapath
    if (!is.null(filepath) && (str_sub(filepath, -9, -1) == ".sas7bdat") ) {
      traintibble <- read_sas(data_file = filepath)
      traindf <- as.data.frame(traintibble)
      data$traindata <- modify_at(traindf,
                                  which(as.character(sapply(traindf, class)) == "character"),
                                  as.factor)
    }
  } else if (input$Data_train_type == "stata") {
    filepath <-  input$Data_train_stata$datapath
    if (!is.null(filepath) && (str_sub(filepath, -4, -1) == ".dta") ) {
      traintibble <- read_stata(file = filepath)
      traindf <- as.data.frame(traintibble)
      data$traindata <- modify_at(traindf,
                                  which(as.character(sapply(traindf, class)) == "character"),
                                  as.factor)
    }
  }
})

output$Data_train_view <- DT::renderDataTable({
  DT::datatable(data$traindata, options = list(scrollX = TRUE))
})

observe({
  toggle(id = "Data_train_view", condition = (!is.null(data$traindata)))
})


# show help if needed
observeEvent(input$User_help, {
  shinyalert(title = "Data Import", text = userhelp[["Data"]], closeOnClickOutside = TRUE, animation = FALSE)
})

# Layout for "Task" UI
tabpanel_Task <- fluidPage(
  fluidRow(
    column(6,
           wellPanel(
             fluidRow(
               column(4,
                      h5("Define a Task", style = "font-weight: bold;"),
                      hr(style = "border-color: #3e3f3a;"),
                      selectInput(inputId = "Task_backend", label = h5("Select Data Backend"),
                                  choices = list( "imported training data", examples = c("iris", "mtcars", "german_credit")),
                                  selected = "iris", multiple = FALSE),
                      uiOutput(outputId = "Task_make_id"),
                      uiOutput(outputId = "Task_make_target"),
                      uiOutput(outputId = "Task_make_task")
               ),
               column(8,
                      tableOutput(outputId = "Task_overview")
                     )
             )
           ),
           wellPanel(
             uiOutput(outputId = "Task_processing")
           )
          ),
    column(6,
           wellPanel(
             uiOutput(outputId = "Task_visualize")
           )
    )
  )
)

# reactive values for benchmarking
Bench <- reactiveValues(Bench_Rslt = NULL, Res_Strat = NULL, Current_Learners = NULL, Current_Design = NULL, Best = NULL,
                        Overview = NULL)

## Functions
# get Learner and resampling choices
getLrnsStrtsUI <- function() {
  if (is.null(LearnerMeta$Learner_Avail)) {
    ui <- tagList(
      fluidRow(
        column(12,
               h5("No learner has been created yet. Please go to step 3 to define a learner.")
        )
      )
    )
    return(ui)
  }
  else {
    ui <- tagList(
      fluidRow(
        column(6,
               checkboxGroupInput(inputId = "Bench_learners", label = h5("Select learners to include in benchmarking:"),
                                  choices = LearnerMeta$Learner_Avail,
                                  selected = character(0))
        ),
        column(6,
               radioButtons(inputId = "Bench_res_strategy", label = h5("Select a resampling strategy:"),
                            choices = c("holdout", "cross-validation" = "cv", "bootstrap"))
        )
      ),
      HTML("<br/>"),
      fluidRow(
        column(12,
               div(style = "display:inline-block; width:100%; text-align: center;",
                   actionButton(inputId = "Bench_start", label = "Start benchmarking")
               )
               )
      )
      )
    return(ui)
  }
}

# get learnerobjects of selected learners and assign them to Bench$Current_Learners
setLrnsObjects <- function() {
  for (i in input$Bench_learners) {
    Bench$Current_Learners[[i]] <- get(i)$Learner$clone(deep = TRUE)
  }
}


# create benchmark overview
getItersOv <- function() {
  if (is.null(Bench$Bench_Rslt)) {
    return("[not available]")
  }
  else {
    return(paste(max(as.data.table(Bench$Bench_Rslt)$iteration), "iterations for", table(as.data.table(Bench$Bench_Rslt)$iteration)[1],"learners", sep = " "))
  }
}

# show selected Learners and their algorithms
getCurrentLearnersOv <- function() {
  if (!is.null(Bench$Current_Learners)) {
    lrns <- paste(sapply(input$Bench_learners, function(x){
      c(paste(x, Bench$Current_Learners[[x]]$label, sep = ": "))
      }), collapse = ", ")
    return(lrns)
  }
}

# find out the best learner once available
getBestLrnOv <- function(){
  if (is.null(Bench$Best)) {
    return("[not available]")
  }
  else{
    learner_info_vec <- NULL
    # Fix-Me: pretty ugly solution, replace for with apply function and paste functions with better function for string handling
    for (learner_number in 1:length(Bench$Current_Learners)) {
      if (Bench$Best[1] == Bench$Current_Learners[[learner_number]]$hash) {
        learner_info_vec = paste(input$Bench_learners[[learner_number]], Bench$Current_Learners[[learner_number]]$label)
      }
    }

    best <- paste(learner_info_vec,
                  paste(input$Bench_measure[length(input$Bench_measure)], round(as.numeric(Bench$Best[2]), 3), sep = ": "),
                  sep = "; ")
    return(best)
  }
}

# create Overview
createBenchOverview <- function() {
  overview <- list(
    Task <- currenttask$task$id,
    Learners <- getCurrentLearnersOv(),
    Strategy <- input$Bench_res_strategy,
    Iterations <- getItersOv(),
    "Best Learner" <- getBestLrnOv()
  )
  return(overview)
}

# create UI for Overview
getBenchOverviewUi <- function() {
  if (is.null(Bench$Current_Learners)) {
    ui <- tagList(
      hr(style = "border-color: #3e3f3a;"),
      fluidRow(
        column(12,
               h5("Benchmarking has not been started yet.")
        )
      )
    )
    return(ui)
  }
  else {
    overviewUi <- tagList(
      hr(style = "border-color: #3e3f3a;"),
      fluidRow(
        column(12,
               h5("Benchmarking Overview", style = "font-weight: bold;"),
               addOverviewLineWf("Task: ", Bench$Overview[[1]]),
               addOverviewLineWf("Learners: ", Bench$Overview[[2]]),
               addOverviewLineWf("Resampling Strategy: ", Bench$Overview[[3]]),
               addOverviewLineWf("Performed Iterations: ", Bench$Overview[[4]]),
               addOverviewLineWf("Best Learner: ", Bench$Overview[[5]])
        )
      )
    )
    return(overviewUi)
  }
}

# resampling params for benchmarking (param functions are in server_resample)
getBenchParams <- function() {
  if (is.null(Bench$Current_Learners)) {
    return(column(12,
                  h5("Benchmarking has not been started yet.")
                  )
    )
  }
  else {
    params <- tagList()
    for (i in rev(Bench$Res_Strat$param_set$ids())) {
      params <- tagAppendChild(params, get(i)(id = "Bench", default = Bench$Res_Strat$param_set$values[[i]]))
    }
    return(params)
  }
}


# get available measures (not nicest solution since is.null check only necessary to toggle measure ui)
getBenchMeasuresUi <- function() {
  if (!is.null(Bench$Bench_Rslt)) {
    measureui <- tagList(
      hr(style = "border-color: #3e3f3a;"),
      h5("Measure Aggregated Performance", style = "font-weight: bold;"),
      fluidRow(
        column(6,
               selectizeInput(inputId = "Bench_measure", label = NULL,
                              choices = get_msrs(currenttask$task, Bench$Current_Learners[[1]], avail_msrs, msr_translations),
                               # options = list(
                               #   placeholder = 'Nothing selected',
                               #   onInitialize = I('function() { this.setValue(""); }')
                               # ),
                              selected = get_msrs(currenttask$task, Wf$Current_Learner, avail_msrs, msr_translations)[1],
                              multiple = TRUE)
        ),
        column(6,
               actionButton(inputId = "Bench_aggr_measure", label = "Score", style = "float: right;")
        )
      )
    )
    return(measureui)
  }
}

# Start Benchmark
getBenchButton <- function() {
  if (!is.null(Bench$Current_Learners)) {
    buttonui <- tagList(
      hr(style = "border-color: #3e3f3a;"),
      fluidRow(
        column(12,
               div(style = "display:inline-block; width:100%; text-align: center;",
                   actionButton(inputId = "Bench_benchmark", label = "Benchmark"),
                   h5("Benchmarking large datasets may take a while.")
               )
        )
      )
    )
    return(buttonui)
  }
}

# show comparison table for the performance of each learner
getBenchTable <- function(aggregated_result) {
  if (!is.null(Bench$Bench_Rslt)) {
    #replace LearnerID with Learner labels
    aggregated_result$learner_id <- sapply(input$Bench_learners, function(x){
      c(Bench$Current_Learners[[x]]$label)})
    #rename column
    aggregated_result <- rename(aggregated_result, learner_name = learner_id)
    
    tabl <-  DT::datatable(aggregated_result[, -c(1,2,3,6)],
                           options = list(scrollX = TRUE,searching = FALSE, ordering = FALSE, bInfo = FALSE,
                                          lengthChange = FALSE, paging = FALSE))
    return(tabl)
  }
}

getBestLrn <- function(aggregated_result) {
  measure <- msr(input$Bench_measure[length(input$Bench_measure)])
  if (measure$minimize) {
    best_perf <- min(aggregated_result[[length(aggregated_result)]])
  }
  else {
    best_perf <- max(aggregated_result[[length(aggregated_result)]])
  }
  best_lrn <- aggregated_result[which(aggregated_result[[length(aggregated_result)]] == best_perf)]
  return(c(best_lrn$resample_result[[1]]$learners[[1]]$hash, best_lrn[[length(best_lrn)]]))
}

# download benchmark
getBenchDownload <- function() {
  if (!is.null(Bench$Bench_Rslt)) {
    downloadbtnui <- tagList(
      hr(style = "border-color: #3e3f3a;"),
      div(style = "display:inline-block; width:100%; text-align: center;",
          downloadButton(outputId  = "Bench_result_download", label = "Export Benchmark Result")
      )
    )
  }
}

## Observers
# make Learner and resampling choices ui
output$Bench_learner_strats_selection <- renderUI({
  getLrnsStrtsUI()
})

observeEvent(input$Bench_start, {
  updateActionButton(session = session, inputId = "Bench_start", label = "Restart benchmarking")
})

output$Bench_overview <- renderUI({
  getBenchOverviewUi()
})

output$Bench_params <- renderUI({
  getBenchParams()
})

output$Bench_measures <- renderUI({
  getBenchMeasuresUi()
})

output$Bench_benchmark_button <- renderUI({
  getBenchButton()
})

output$Bench_download <- renderUI({
  getBenchDownload()
})

output$Bench_result_download <- downloadHandler(
  filename = function() {
    paste(paste("BenchmarkResult", Bench$Res_Strat$id, sep = "_"), ".rds", sep = "")
  },
  content = function(file) {
    saveRDS(Bench$Bench_Rslt, file = file)
  }
)

# benchmark
observeEvent(input$Bench_benchmark, {
  paramsbench <- list()
  for (i in Bench$Res_Strat$param_set$ids()) {
    paramsbench[[i]] <- input[[paste0("Bench_", i)]]
  }
  withProgress(message = "Computing benchmark", style = "notification",
               withCallingHandlers(
                 tryCatch({Bench$Res_Strat$param_set$values <- paramsbench
                 set.seed(42)
                 incProgress(0.2)
                 Bench$Current_Design <- benchmark_grid(tasks = currenttask$task, learners = Bench$Current_Learners, resamplings = Bench$Res_Strat)
                 incProgress(0.4)
                 Bench$Bench_Rslt <- benchmark(Bench$Current_Design)
                 incProgress(0.6)
                 },
                 error = errorAlertBench
                 ),
                 warning = warningAlert
               )
  )
  Bench$Overview <- createBenchOverview()
})

observeEvent(input$Bench_aggr_measure, {
  # aggregate the results and find the best learner based on the last measure provided
  # try catch since learners require same predict type for measure -> easy error handling
  withProgress(message = "Initialising scoring", style = "notification", 
      withCallingHandlers(
        tryCatch({
        incProgress(0.5)
        aggr_rslt <- Bench$Bench_Rslt$aggregate(msrs(c(input$Bench_measure)))
        Bench$Best <- getBestLrn(aggr_rslt)
      },
      error = errorAlertBenchAggr
      ),
      warning = warningAlert
      ))
  
  output$Bench_rslt_view <- DT::renderDataTable({
    getBenchTable(aggr_rslt)
  })
  Bench$Overview <- createBenchOverview()
})

# toggle the well panel only after performance was evaluated to avoid overview of results without valuable information
observe({
  toggle(id = "Bench_well_rslt", condition = !is.null(Bench$Best))
})

resetBench <- function() {
  Bench$Current_Learners = NULL
  Bench$Bench_Rslt = NULL
  Bench$Current_Design = NULL
  Bench$Best = NULL
  Bench$Overview = NULL
}

observeEvent(input$Bench_start, {
  if (!is.null(input$Bench_learners)) {
    resetBench()
    setLrnsObjects()
    Bench$Res_Strat <- rsmp(input$Bench_res_strategy)
    Bench$Overview <- createBenchOverview()
  }
  else {
    shinyalert(title = "No Learner Selected",
               text = paste("In order to start benchmarking, learners must be selected.",
                            sep = " "),
               animation = FALSE,
               closeOnClickOutside = TRUE,
               className="alert-warning",)
  }
})

observeEvent(currenttask$task, {
  resetBench()
})

# reactive values for the chosen learner, the features selected and the iml objects used for explaining the model
eval_meta <- reactiveValues(current_learner = NULL, 
                            selected_features = NULL, 
                            feature_effect_num = NULL,
                            feature_effect_cat = NULL,
                            cat_list = NULL,
                            num_list = NULL,
                            feature_importance = NULL, 
                            feature_importance_compare = NULL)

# shiny outputs for the ui
output$eval_learner_selection <- renderUI({
  get_learner_selection()
})

output$eval_explanation_selection <- renderUI({
  get_explanation_selection()
})

output$eval_loss_function_selection <- renderUI({
  loss_ui_builder_new(currenttask$task, input$selected_learner)
})

output$eval_compare_method_selection <- renderUI({
  get_compare_method_list()
})

output$eval_automation_slider <- renderUI({
  compute_slider_values()
})

output$eval_analysis_plot_selection <- renderUI({
  get_analysis_plot()
})

output$eval_analysis_automation <- renderUI({
get_selection_automation()  
})

output$eval_learner_feat_selection <- renderUI({
  get_feature_selection()
})

output$eval_learner_plot_tabs <- renderUI({
  display_plot_tabs()
})

##display warning message if model interpretation may fail and how the user can avoid this
observeEvent(input$explanation_selection, {
  if(isTRUE(currenttask$task$properties == "multiclass" && eval_meta$current_learner$predict_type == "response")){
    
    shinyalert(title = "Notification",
               text = paste("You chose a response type in the learner tab. This is currently not supported.",
                            "Try training a model with the predict type set to 'Probability' to fix this"),
               animation = FALSE, closeOnClickOutside = TRUE)
  }
  
})

# observe "start evaluation" button and start DALEX Workflow
observeEvent(input$evaluate_start, {
  withProgress(message = "Initialising evaluation", style = "notification",
      withCallingHandlers(
      tryCatch({
        if (isTRUE(currenttask$task$properties == "twoclass") ){
          
          #Preparation for Explainer | TASK
          dalex_temp <- currenttask$task$data(data_format = "data.table")
          dalex_predictors <- dalex_temp %>% select(-currenttask$task$target_names)
          dalex_target <- dalex_temp %>% select(currenttask$task$target_names)
          colnames(dalex_target) <- "target"
        
          dalex_target$target <- as.character(dalex_target$target)
          dalex_target$target[dalex_target$target == currenttask$task$positive] <- "1"
          dalex_target$target[dalex_target$target != "1"] <- "0"
          
          incProgress(0.1, paste("Initialising Workflow"))
          
          #creating the DALEX(tra) Explainer object for further computations
          
          model <- explain_mlr3(eval_meta$current_learner,
                                data = dalex_predictors, 
                                y = as.numeric(dalex_target$target),
                                predict_function_target_column = currenttask$positive,
                                verbose = TRUE) 
          
          
          incProgress(0.2, paste("Creating Explainer"))
         
        }
      
        #starting the other workflow for multiclass/ regression models
        else{
        dalex_temp <- currenttask$task$data(data_format = "data.table")
        dalex_predictors <- dalex_temp %>% select(-currenttask$task$target_names)
        dalex_target <- dalex_temp %>% select(currenttask$task$target_names)
        
        incProgress(0.1, paste("Initialising Workflow"))
        
        #creating the DALEX(tra) Explainer object for further computations
        
        model <- explain_mlr3(eval_meta$current_learner, 
                         data = dalex_predictors, 
                         y = dalex_target,
                         verbose = FALSE)
                         
        
        incProgress(0.2, paste("Creating Explainer"))
        }
        
        # Computing Results based on the User Input
        if("Feature importance" %in% input$explanation_selection){
          incProgress(0.4, paste("Computing feature importance"))  
          eval_meta$feature_importance <- model_parts(
                model, 
                loss_function = match.fun(input$loss_picker), 
                type = input$compare_picker)
            plot_feature_importance()
        }
        
        
        if("Specific feature analysis" %in% input$explanation_selection && input$automation_flag == "manual"){
          incProgress(0.6, paste("Computing plot: ", input$method_picker))  
          specific_feature_analysis(eval_meta$selected_features, model)
        }
        
        if("Specific feature analysis" %in% input$explanation_selection && input$automation_flag == "automatic"){
          incProgress(0.6, paste("Computing plot: ", input$method_picker))
          
          #1. Compute VI in a time efficient manner
          temp_var_imp <- model %>% model_parts(B=1)
          #2. Get Vector of most important columns from worst to best
          temp_var_imp_vector <- temp_var_imp$variable
          #3. Remove Target
          temp_var_imp_vector <- temp_var_imp_vector[!temp_var_imp_vector == currenttask$task$target_names]
          #4. Remove Base_line and __full_model__
          len <- length(temp_var_imp_vector)
          temp_var_imp_vector <- head(tail(temp_var_imp_vector,len-1), len-2)
          
          specific_feature_analysis(tail(temp_var_imp_vector, as.numeric(input$automation_slider)), model)
        }
        incProgress(0.8, paste("Finishing Plot"))
        
        
      },
      error = errorAlertTrain
      )
    )
  )
})

# observe chosen learner in ui and change meta object
observeEvent(input$selected_learner, {
  reset_evaluation()
  eval_meta$current_learner <- trained_learner_list[[input$selected_learner]]
  # showing only relevant loss functions
  reset_plots()
})

# save selected features and reset plot diagrams
observeEvent(input$feat_picker, {
  eval_meta$selected_features <- input$feat_picker
})

#builder for explanation selection
get_explanation_selection <- function() {
  if (!is.null(input$selected_learner)) {
    ui <- tagList(
      fluidRow(
        column(
          12,
          h5("Choose explanation method", style = "font-weight: bold;"),
          hr(style = "border-color: #3e3f3a;"),
        ),
        column(
          12,
          checkboxGroupInput(inputId = "explanation_selection", 
                             label = NULL,
                             choices = c("Feature importance", 
                                         "Specific feature analysis"),
                             selected = c("Feature importance", 
                                          "Specific feature analysis")
                             )
        )
      )
    )
    return(ui)
    
  }
  
}

# builder for compare method selection
get_compare_method_list <- function() {
  if (!is.null(input$selected_learner)) {
    if("Feature importance" %in% input$explanation_selection){
    ui <- tagList(
      
      fluidRow(
        column(
          12,
          h5("Select compare method for Feature Importance:")
        ),
        column(
          12,
          pickerInput("compare_picker",
            choices = c("ratio", "raw")
          )
        )
      )
    )
    return(ui)}
  }
}


#UI Builder for loss_function selection
loss_ui_builder_new <- function(task, learner) {
  if (!is.null(input$selected_learner)) {
    if("Feature importance" %in% input$explanation_selection){
  ui <- tagList(
    fluidRow(
      column(
        12,
        h5("Feature importance", style = "font-weight: bold;"),
        hr(style = "border-color: #3e3f3a;"),
      )
    ),
    fluidRow(
      column(
        12,
        h5("Select loss function for Feature Importance: "),
      )
    ),
    if(task$task_type == "classif"){
      if (task$properties == "twoclass"){
        fluidRow(
        column(
        12,
        pickerInput("loss_picker",
                   choices = c("One-Minus-AUC" = "loss_one_minus_auc")
          )
         )
        )
      }
      else{
        fluidRow(
          column(
            12,
            pickerInput("loss_picker",
                        choices = c("Cross-Entropy (Log loss)" = "loss_cross_entropy"
                                    )
            )
          )
        )
      }
                                    }
    
   
    else if(task$task_type == "regr"){
      fluidRow(
        column(
          12,
          pickerInput("loss_picker",
                      choices = c(
                        "Sum of Squared (SSE)" = "loss_sum_of_squares",
                        "Root Mean Square (RMSE)" = "loss_root_mean_square"
                      )
          )
        )
      ) 
      
    }
  )
  return(ui)
    }
  }
  }

#compute slider values
compute_slider_values <- function(){
      if("automatic" %in% input$automation_flag){
        
        ui <- tagList( 
          fluidRow(
            column(
              12,
              h5("Choose how many features you want to display:"),
            ),
            column(
              12,
              h5("The actual amount of features displayed may vary."),
            ),
            column(
              12,
              sliderInput("automation_slider",label = "", step = 1, min = 1, 
                          max = length(features_to_use$features), value = 1)
              
            )
          )
        )
      }
}


#get the plot information
get_analysis_plot <- function(){
  if (!is.null(input$selected_learner)) {
  if("Specific feature analysis" %in% input$explanation_selection){
   ui <- tagList( 
     fluidRow(
       column(
         12,
         h5("Specific feature analysis", style = "font-weight: bold;"),
         hr(style = "border-color: #3e3f3a;"),
       )
     ),
     fluidRow(
       column(
         12,
         h5("Select plot to display: "),
       )
     ),
     fluidRow(
      column(
        12,
        pickerInput("method_picker",
                    choices = c("PD-plot" ="partial", 
                                "ALE-Plot" = "accumulated",
                                "ICE-plot" = "conditional"),
                    
        )
      )
    )
   )
  }
  }
}


# get all possible features from the selected learner
get_feature_selection <- function() {
  if (!is.null(input$selected_learner)) {
  if("Specific feature analysis" %in% input$explanation_selection){
    if("manual" %in% input$automation_flag){
  ui <- tagList(
    fluidRow(
      column(
        12,
        h5("Select Features to show in Feature-Analysis-Plot:")
      )
    ),
    fluidRow(
      column(
        12,
        pickerInput("feat_picker",
          choices = c(currenttask$featNames),
          multiple = TRUE
        )
      )
    ),
  )
}}}}

# of all existing learners return a list of the already trained ones
# this loop is necessary as it's not possible to loop through a reactiveValue like "trained_learner_list"
get_trained_learners <- function() {
  list_of_learners <- list()
  for (learner in LearnerMeta$Learner_Avail) {
    if (!is.null(trained_learner_list[[learner]])) {
      list_of_learners <- append(list_of_learners, learner)
    }
  }
  return(list_of_learners)
}


# get all possible learners
get_learner_selection <- function(list_of_learners) {
  if (length(reactiveValuesToList(trained_learner_list)) == 0) {
    ui <- tagList(
      fluidRow(
        column(
          12,
          h5("No learner has been trained on the whole dataset, go back to the previous tab to train on the whole dataset")
        )
      )
    )
    return(ui)
  } else {
    ui <- tagList(
      fluidRow(
        column(
          12,
          h5("Explain your model", style = "font-weight: bold;"),
          hr(style = "border-color: #3e3f3a;"),
        ),
        column(
          12,
          radioButtons(
            inputId = "selected_learner",
            label = h5("Select a learner to evaluate its performance."),
            choices = get_trained_learners(),
            selected = character(0)
          )
        )
      )
    )
    return(ui)
  }
}

#Split numeric and categorical values
specific_feature_analysis <- function(list, explainer){
  #initialise categorical list and numeric list
  #Here feature_type = POSIXct is excluded
  eval_meta$num_list <- currenttask$task$feature_types[currenttask$task$feature_types$type == "numeric" | 
                                                  currenttask$task$feature_types$type == "integer",]
  eval_meta$num_list <- eval_meta$num_list$id
  if(length(intersect(list, eval_meta$num_list)) > 0){
  
    eval_meta$feature_effect_num <- model_profile(
      explainer, 
      variables <- intersect(eval_meta$num_list, list),
      type = input$method_picker)
    
    plot_feature_analysis_num(eval_meta$feature_effect_num)
  }

  eval_meta$cat_list <- currenttask$task$feature_types[currenttask$task$feature_types$type == "ordered" | 
                                                  currenttask$task$feature_types$type == "factor" | 
                                                  currenttask$task$feature_types$type == "character" | 
                                                  currenttask$task$feature_types$type == "logical",]
  eval_meta$cat_list <- eval_meta$cat_list$id
  
  if(length(intersect(list, eval_meta$cat_list)) > 0){
  eval_meta$feature_effect_cat <- model_profile(
    explainer, 
    variables <- intersect(eval_meta$cat_list, list),
    type = input$method_picker)
  
  plot_feature_analysis_cat(eval_meta$feature_effect_cat)
  }
  
}


  
  
#plot function for feature importance
plot_feature_importance <- function(){
  output$feature_imp_plot <- renderPlot({
    plot(eval_meta$feature_importance)
  })
  
}

#plot functions for model_profile, separated by feature types
plot_feature_analysis_num <- function(x){
  output$feature_analysis_plot_num <- renderPlot({
    plot(x, geom = "aggregates")
  })
}
plot_feature_analysis_cat <- function(x){
  output$feature_analysis_plot_cat <- renderPlot({
    plot(x, geom = "aggregates")
  })
}

#display option to automate feature analysis or make it manual

get_selection_automation <- function(){
  if("Specific feature analysis" %in% input$explanation_selection){
    ui <- tagList(
        column(
          12,
          radioButtons(
            inputId = "automation_flag",
            label = h5("Choose method for analysis"),
            choices = c("manual", "automatic")
          )
        )
      )
    return(ui)
    
  }
  
}

# display a tabPanel for the PDP and VI plots
display_plot_tabs <- function() {
  #if Feature imp is selected
  #Ding Ding Ding
  if (!is.null(eval_meta$feature_importance) && is.null(eval_meta$feature_effect_num) && !is.null(input$selected_learner)) {
    ui <- tabsetPanel(
      type = "tabs",
      tabPanel(
        "Feature Importance",
        wellPanel(
          plotOutput(outputId = "feature_imp_plot")
        )
      )
    )
    return(ui)
  }
  #if feature analysis is selected
  if (is.null(eval_meta$feature_importance) && !is.null(eval_meta$feature_effect_num) && !is.null(input$selected_learner)) {
    if(!is.null(eval_meta$cat_list) && is.null(eval_meta$num_list)){
    ui <- tabsetPanel(
      type = "tabs",
        tabPanel(
          "Feature-Analysis-Plot",  
          wellPanel(
            plotOutput(outputId = "feature_analysis_plot_cat")
          )
        )
    )}
    #CAT No NUM YES
    if(is.null(eval_meta$cat_list) && !is.null(eval_meta$num_list)){
      ui <- tabsetPanel(
        type = "tabs",
        tabPanel(
          "Feature-Analysis-Plot",
          wellPanel(
            plotOutput(outputId = "feature_analysis_plot_num")
          ))
      )
    }
    else{
      ui <- tabsetPanel(
        type = "tabs",
        tabPanel(
          "Feature-Analysis-Plot",
          wellPanel(
            plotOutput(outputId = "feature_analysis_plot_num")
          ),
          tabPanel(
            "",  
            wellPanel(
              plotOutput(outputId = "feature_analysis_plot_cat")
            )
          ))
      )
    }
    return(ui)
  }
  #if both are selected
  if (!is.null(eval_meta$feature_importance) && !is.null(eval_meta$feature_effect_num) && !is.null(input$selected_learner)) {
    ui <- tabsetPanel(
      type = "tabs",
      tabPanel(
        "Feature Importance",
        wellPanel(
          plotOutput(outputId = "feature_imp_plot")
        )
      ),
      tabPanel(
        "Feature-Analysis-Plot",
        wellPanel(
          plotOutput(outputId = "feature_analysis_plot_num")
        ),
        tabPanel(
        "",  
        wellPanel(
          plotOutput(outputId = "feature_analysis_plot_cat")
        )
      ))
    )
    return(ui)
  }
}

# helper for resetting the eval_meta object
reset_evaluation <- function() {
  eval_meta$current_learner <- NULL
  eval_meta$feature_effect_num <- NULL
  eval_meta$feature_effect_cat <- NULL
  eval_meta$feature_importance <- NULL
}

# helper for resetting the plots in the ui
reset_plots <- function() {
  output$feature_analysis_plot_num <- NULL
  output$feature_analysis_plot_cat <- NULL
  output$feature_imp_plot <- NULL
}

observe({
  if (!is.null(input$selected_learner)) {
    show("feature_selection_panel")
  }
})

# disabling the start button if no feature is selected
observe({
  if (length(input$feat_picker) == 0 &&"Specific feature analysis" %in% input$explanation_selection && "automation_flag" == "manual") {
    disable("evaluate_start")
  } else {
    enable("evaluate_start")
  }
})

# Layout of "Resampling" UI
resample_ui <- fluidRow(
  id = "TrainFit_Resample",
  column(4,
         wellPanel(
           fluidRow(
             column(6,
                    h5("Resampling", style = "font-weight: bold;")
             ),
             column(6,
                    actionButton(inputId = "TrainFit_Base", label = "Back to Basic")
             )
           ),
           hr(style = "border-color: #3e3f3a;"),
           uiOutput(outputId = "Res_learner_selection"),
           fluidRow(
             column(12,
                    uiOutput(outputId = "Res_overview")
             )
           ),
           fluidRow(
             column(12,
                    uiOutput(outputId = "Res_download")
             )
           )
        )
  ),
  column(4,
         wellPanel(
           h5("Resampling Parameter Settings", style = "font-weight: bold;"),
           fluidRow(
             uiOutput(outputId = "Res_params")
           ),
           uiOutput(outputId = "Res_resample_button"),
           uiOutput(outputId = "Res_measure")
         )
         ),
  column(4,
         hidden(
           wellPanel(
             id = "Res_well_prediction",
             h5("Combined Predicitons of Target Variable", style = "font-weight: bold;"),
             DT::dataTableOutput(outputId = "Res_pred_view")
           )
         )
  )
)

# Layout of benchmarking UI
tabpanel_benchmarking <- fluidPage(
  fluidRow(
    column(4,
           wellPanel(
             fluidRow(
               column(12,
                      h5("Create a Benchmark Design", style = "font-weight: bold;")
               )
             ),
             hr(style = "border-color: #3e3f3a;"),
             uiOutput(outputId = "Bench_learner_strats_selection"),
             fluidRow(
               column(12,
                      uiOutput(outputId = "Bench_overview")
               )
             ),
             fluidRow(
               column(12,
                      uiOutput(outputId = "Bench_download")
               )
             )
           )
    ),
    column(4,
           wellPanel(
             h5("Resampling Parameter Settings", style = "font-weight: bold;"),
             fluidRow(
               uiOutput(outputId = "Bench_params")
             ),
             uiOutput(outputId = "Bench_benchmark_button"),
             uiOutput(outputId = "Bench_measures")
           )
    ),
    column(4,
           hidden(
             wellPanel(
               id = "Bench_well_rslt",
               h5("Aggregated Benchmark Result", style = "font-weight: bold;"),
               DT::dataTableOutput(outputId = "Bench_rslt_view")
             )
           )
           )
  ),
)

# each Learner has its own reactive values
LearnerMeta <- reactiveValues(Count = 1, learner_choice = NULL, Learner_Avail = NULL, TwoClass = NULL)
Learner1 <- reactiveValues(Learner = NULL, Overview = NULL, Params = list(), Predict_Type = NULL, Hash = NULL, Learner_Name = NULL)
Learner2 <- reactiveValues(Learner = NULL, Overview = NULL, Params = list(), Predict_Type = NULL, Hash = NULL, Learner_Name = NULL)
Learner3 <- reactiveValues(Learner = NULL, Overview = NULL, Params = list(), Predict_Type = NULL, Hash = NULL, Learner_Name = NULL)
Learner4 <- reactiveValues(Learner = NULL, Overview = NULL, Params = list(), Predict_Type = NULL, Hash = NULL, Learner_Name = NULL)
Learner5 <- reactiveValues(Learner = NULL, Overview = NULL, Params = list(), Predict_Type = NULL, Hash = NULL, Learner_Name = NULL)
Learner6 <- reactiveValues(Learner = NULL, Overview = NULL, Params = list(), Predict_Type = NULL, Hash = NULL, Learner_Name = NULL)
Learner7 <- reactiveValues(Learner = NULL, Overview = NULL, Params = list(), Predict_Type = NULL, Hash = NULL, Learner_Name = NULL)

# list of trained learners (will be dynamically filled in the training process)
trained_learner_list <- reactiveValues()

# reset a single trained learner
# used when the learner type or params are changed
reset_single_trained_learner <- function(learner_name) {
   if (!is.null(trained_learner_list)) {
      trained_learner_list[[learner_name]] <- NULL
   }
}

# reset the whole list of trained learners
reset_trained_learner_list <- function() {
   # iterating over all trained learners and resetting them
   # See: https://stackoverflow.com/questions/61887112/how-to-reset-reactivevalues
   for (trained_learner in names(trained_learner_list)) {
      trained_learner_list[[trained_learner]] <- NULL
   }
}

# check whether it is a regression or classification and then give possible learners for each
observe({
   if (!is.null(currenttask$task) && currenttask$task$task_type == "classif") {
      basic_choice <- c("decision tree" = "classif.rpart", "random forest" = "classif.ranger", "support vector machine" = "classif.svm", "xgboost" = "classif.xgboost")
      if (currenttask$task$properties == "multiclass") {
         LearnerMeta$learner_choice <- basic_choice
      } else {
         LearnerMeta$TwoClass <- TRUE
         LearnerMeta$learner_choice <- c(basic_choice, "logistic regression" = "classif.log_reg")
      }
   } else if (!is.null(currenttask$task) && currenttask$task$task_type == "regr") {
      LearnerMeta$learner_choice <- c(
         "decision tree" = "regr.rpart", "linear regression" = "regr.lm", "random forest" = "regr.ranger",
         "support vector machine" = "regr.svm", "xgboost" = "regr.xgboost"
      )
   }
})

# let's user add another learner object
addLearner <- function(LearnNumber) {
   tagList(
      fluidRow(
         column(
            3,
            h5(paste("Learner", (LearnNumber), sep = " "))
         ),
         column(
            6,
            selectInput(inputId = paste0("Learner_Learner", LearnNumber), label = NULL, choices = LearnerMeta$learner_choice, selected = "decision tree")
         ),
         column(
            3,
            actionButton(
               inputId = paste0("Learner_Create", LearnNumber), label = "Go", icon = icon("filter"),
               style = "float:right;"
            )
         )
      )
   )
}

output$Learner_other_Learner1 <- renderUI({
   addLearner(LearnNumber = 1)
})

# ui for each learner selection with name, choices and go button
observeEvent(input$Learner_add, {
   LearnerMeta$Count <- LearnerMeta$Count + 1
   currentcount <- LearnerMeta$Count
   switch(as.character(currentcount),
      "2" = {
         output$Learner_other_Learner2 <- renderUI({
            addLearner(currentcount)
         })
      },
      "3" = {
         output$Learner_other_Learner3 <- renderUI({
            addLearner(currentcount)
         })
      },
      "4" = {
         output$Learner_other_Learner4 <- renderUI({
            addLearner(currentcount)
         })
      },
      "5" = {
         output$Learner_other_Learner5 <- renderUI({
            addLearner(currentcount)
         })
      },
      "6" = {
         output$Learner_other_Learner6 <- renderUI({
            addLearner(currentcount)
         })
      },
      "7" = {
         output$Learner_other_Learner7 <- renderUI({
            addLearner(currentcount)
         })
      },
      {
         shinyalert(
            title = "Maximum Reached",
            text = "Currently a maximum of 7 learners at the same time is supported.",
            animation = FALSE, closeOnClickOutside = TRUE
         )
      }
   )
})

# only show learner panels when at least one is created otherwise give user info that no learner has been created yet
observe({
   checkcondition <- is.null(c(
      Learner1$Learner, Learner2$Learner, Learner3$Learner, Learner4$Learner,
      Learner5$Learner, Learner6$Learner, Learner7$Learner
   ))
   toggle(id = "Learner_NA", condition = checkcondition)
   toggle(id = "Learner_Learners", condition = !checkcondition)
})

hideorshowTab <- function(learnerobject, target) {
   if (is.null(learnerobject)) {
      hideTab(inputId = "Learner_Learners_Tab", target = target)
   } else {
      showTab(inputId = "Learner_Learners_Tab", target = target, select = TRUE)
   }
}

# for now this way, in case removal of learners is implemented.
# else, place function in observeEvent for each Learner
observe({
   hideorshowTab(Learner1$Learner, "Learner 1")
   hideorshowTab(Learner2$Learner, "Learner 2")
   hideorshowTab(Learner3$Learner, "Learner 3")
   hideorshowTab(Learner4$Learner, "Learner 4")
   hideorshowTab(Learner5$Learner, "Learner 5")
   hideorshowTab(Learner6$Learner, "Learner 6")
   hideorshowTab(Learner7$Learner, "Learner 7")
})

# Learner tabs
## Learner overview

# get set params
getCurrentParams <- function(learnerobject) {
   selectedParams <- character(0)
   for (i in names(learnerobject$Learner$param_set$values)) {
      selectedParams <- paste(c(selectedParams, paste(i, learnerobject$Learner$param_set$values[[i]],
         sep = ": "
      )), collapse = ", ")
   }
   return(selectedParams)
}

getLearnerOverview <- function(learnerobject) {
   overview <- list(
      "name" = getDisplayLearnerName(learnerobject),
      "predict type" = learnerobject$Learner$predict_type,
      # do not include params as svm still remembers parameter set for radial kernel such as gamma, even though it is not
      # used in linear kernel -> confusing for user
      # "params" = getCurrentParams(learnerobject = learnerobject),
      # using the original learner object because "predict_types"
      # cant be retrieved from a learner returned from as_learner()
      "predict types" = learnerobject$Learner$predict_types,
      "properties" = learnerobject$Learner$properties,
      "feature types" = learnerobject$Learner$feature_types
   )
   return(overview)
}

getDisplayLearnerName <- function(learnerobject) {
   for (learnername in possiblelearners) {
      if (grepl(learnername, learnerobject$Learner$id, fixed = TRUE)) {
         return(names(which(possiblelearners == learnername)))
      }
   }
}

addOverviewLineLearner <- function(title, body) {
   fluidRow(
      column(6, h5(title)),
      column(6, h5(body))
   )
}

makeOverviewUi <- function(learnerobject) {
   overviewUi <- tagList(
      fluidRow(
         column(
            6,
            addOverviewLineLearner("Algorithm: ", learnerobject$Overview[[1]]),
            addOverviewLineLearner("Current Predict Type: ", learnerobject$Overview[[2]]),
            # addOverviewLineLearner("Current Parameter: ", paste(learnerobject$Overview[[3]], collapse = ", "))
            addOverviewLineLearner("Supported Predict Types: ", paste(learnerobject$Overview[[3]], collapse = ", ")),
            textInput(inputId = paste0(learnerobject$Learner_Name, "LabelChoice"), label = "Label:", value = "", width = NULL, placeholder = "Create Learner label"),
            actionButton(inputId = paste0(learnerobject$Learner_Name, "LabelChange"), label = "Update Label", style = "float: left;")
            ),
         column(
            6,
            # addOverviewLineLearner("Supported Predict Types: ", paste(learnerobject$Overview[[4]], collapse = ", ")),
            addOverviewLineLearner("Properties: ", paste(learnerobject$Overview[[4]], collapse = ", ")),
            addOverviewLineLearner("Supported Feature Types: ", paste(learnerobject$Overview[[5]], collapse = ", "))
         )
      )
   )
   return(overviewUi)
}

## Learner params
addNumericParam <- function(id, lower, upper, learnername, default, stpsize = 1) {
   if (missing(default)) {
      default <- 0
   }
   fluidRow(
      column(
         3,
         h5(id)
      ),
      column(
         3,
         h5(paste("Lower:", lower, sep = " "))
      ),
      column(
         3,
         h5(paste("Upper:", upper, sep = " "))
      ),
      column(
         3,
         numericInput(
            inputId = paste0(learnername, "Param", id), label = NULL,
            value = default, min = lower, max = upper, step = stpsize
         )
      )
   )
}



addFactorParam <- function(id, levels, learnername, default) {
   fluidRow(
      column(
         3,
         h5(id)
      ),
      column(
         6,
         h5(paste("Levels:", paste(levels, collapse = ", "), sep = " "))
      ),
      column(
         3,
         selectInput(inputId = paste0(learnername, "factor",id), label = NULL, 
                     choices = levels, selected = default)
      )
   )
}

# for svm to restrict parameter choice for now
# however, now this is not a good expandable solution - just a quick one; better to just offer all params and drop unused ones silently

getKernelParams <- function(learnerobject, learnername, selectedkernel) {
   # Input: current mlr3 learner, learner name (learner1, learner2 etc), user input for kernel
   # Generates a ui taglist to display additional hyperparameter that are available for selected kernel
   # Implicitly updates available hyperparameters depending on kernel for later hyperparameter adjustment (not ideal - function with side effects!)
   # Returns: taglist for kernelparamet

   if (selectedkernel == "polynomial") {
      kernelparams <- tagList(
         addNumericParam(
            id = paste0(learnerobject$Learner_Name, ".", "gamma"), lower = learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "gamma")]$lower,
            upper = learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "gamma")]$upper,
            learnername = learnername, default = learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "gamma")]$default,
            stpsize = 0.1
         ),
         addNumericParam(
            id = paste0(learnerobject$Learner_Name, ".", "degree"), lower = learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "degree")]$lower,
            upper = learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "degree")]$upper,
            learnername = learnername, default = learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "degree")]$default
         )
      )
      # update learnerobject$Params so that only the hyperparams are set that are actually available
      learnerobject$Params <- c(
         learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "kernel")],
         learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "cost")],
         learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "gamma")],
         learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "degree")]
      )
      return(kernelparams)
   } else if (selectedkernel == "radial" || selectedkernel == "sigmoid") {
      kernelparams <- tagList(
         addNumericParam(
            id = paste0(learnerobject$Learner_Name, ".", "gamma"), lower = learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "gamma")]$lower, upper = learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "gamma")]$upper,
            learnername = learnername, default = learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "gamma")]$default,
            stpsize = 0.1
         )
      )
      learnerobject$Params <- c(
         learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "kernel")],
         learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "cost")],
         learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "gamma")]
      )
      return(kernelparams)
   } else {
      learnerobject$Params <- c(
         learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "kernel")],
         learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", "cost")]
      )
      return(NULL)
   }
}

getAvailableParams <- function(algorithm, learnerobject) {
   # Input: Selected algorithm as defined in global, learnerobject that refers to an mlr3 learner
   # Selects available parameters for given algorithm from global and gets parameter details through mlr3
   # Implicitly assigns available hyperparameter to learner$Params for later reference when setting hyperparams
   # Output: list of parameters with id, lower and upper levels, defaults
   params <- list()
   if (grepl("log_reg", learnerobject$Learner$id)) {
     params[[length(params) + 1]] <- learnerobject$Learner$param_set$params[id == "threshold.thresholds"]
   }
   else{
     for (i in 1:length(learnerparams[[algorithm]])) {
        # concatenating the learner id (e.g. "classif.rpart") with a . and the actual parameter
        # this is required because the graph learner stores all parameters in this format
        # example: "classif.rpart.maxdepth"
        params[[i]] <- learnerobject$Learner$param_set$params[id == paste0(learnerobject$Learner_Name, ".", learnerparams[[algorithm]][i])]
     } #paste0(learnerobject$Learner_Name, ".", learnerparams[[algorithm]][i])
     if (grepl("threshold", learnerobject$Learner$id)) {
        params[[length(params) + 1]] <- learnerobject$Learner$param_set$params[id == "threshold.thresholds"]
     }
   }
   learnerobject$Params <- params
   return(params)
}

# define the parameter settings UI for each learner depending on the selected algorithm
makeParamUi <- function(learnerobject, learnername) {
   # Input: mlr3 learner object, name of currently selected learner (learner1, learner2 etc)
   # Creates layout for hyperparameters as a taglist depending on the algorithm
   # Returns: taglist of inputs for Learner hyperparameters
   parameterui <- NULL

   if (learnerobject$Learner$param_set$is_empty) {
      return(h5("No Parameters available to be set.", style = "text-align: center;"))
   } else if (grepl("ranger", learnerobject$Learner$id, fixed = TRUE)) {
      params <- getAvailableParams(algorithm = "ranger", learnerobject = learnerobject)
      # TO-DO: Get a better solution - ugly and repetitive
      if (grepl("threshold", learnerobject$Learner$id)) {
         parameterui <- tagList(
            # num.trees
            addNumericParam(
               id = params[[1]]$id, lower = params[[1]]$lower, upper = params[[1]]$upper, learnername = learnername,
               default = params[[1]]$default
            ),
            # mtry upper needs to be restricted to number of features since mlr ships with Inf as upper value
            addNumericParam(
               id = params[[2]]$id, lower = params[[2]]$lower, upper = length(currenttask$task$feature_names), learnername = learnername,
               default = params[[2]]$default
            ),
            # min.node.size
            addNumericParam(
               id = params[[3]]$id, lower = params[[3]]$lower, upper = params[[3]]$upper, learnername = learnername,
               default = params[[3]]$default
            ),
            addNumericParam(id = params[[length(params)]]$id, lower = 0, upper = 1, learnername = learnername, default = 0.5, stpsize = 0.1),
            actionButton(inputId = paste0(learnername, "ChangeParams"), label = "Change Parameters", style = "float: right;")
         )
      } else {
         parameterui <- tagList(
            # num.trees
            addNumericParam(
               id = params[[1]]$id, lower = params[[1]]$lower, upper = params[[1]]$upper, learnername = learnername,
               default = params[[1]]$default
            ),
            # mtry upper needs to be restricted to number of features since mlr ships with Inf as upper value
            addNumericParam(
               id = params[[2]]$id, lower = params[[2]]$lower, upper = length(currenttask$task$feature_names), learnername = learnername,
               default = params[[2]]$default
            ),
            # min.node.size
            addNumericParam(
               id = params[[3]]$id, lower = params[[3]]$lower, upper = params[[3]]$upper, learnername = learnername,
               default = params[[3]]$default
            ),
            actionButton(inputId = paste0(learnername, "ChangeParams"), label = "Change Parameters", style = "float: right;")
         )
      }
   } else if (grepl("rpart", learnerobject$Learner$id, fixed = TRUE)) {
      params <- getAvailableParams(algorithm = "rpart", learnerobject = learnerobject)
      if (grepl("threshold", learnerobject$Learner$id)) {
         parameterui <- tagList(
            addNumericParam(
               id = params[[1]]$id, lower = params[[1]]$lower, upper = params[[1]]$upper, learnername = learnername,
               default = params[[1]]$default, stpsize = 1
            ),
            addNumericParam(
               id = params[[2]]$id, lower = params[[2]]$lower, upper = params[[2]]$upper, learnername = learnername,
               default = params[[2]]$default, stpsize = 0.0025
            ),
            addNumericParam(
               id = params[[3]]$id, lower = params[[3]]$lower, upper = params[[3]]$upper, learnername = learnername,
               default = params[[3]]$default, stpsize = 1
            ),
            addNumericParam(id = params[[length(params)]]$id, lower = 0, upper = 1, learnername = learnername, default = 0.5, stpsize = 0.1),
            actionButton(inputId = paste0(learnername, "ChangeParams"), label = "Change Parameters", style = "float: right;")
         )
      } else {
         parameterui <- tagList(
            addNumericParam(
               id = params[[1]]$id, lower = params[[1]]$lower, upper = params[[1]]$upper, learnername = learnername,
               default = params[[1]]$default, stpsize = 1
            ),
            addNumericParam(
               id = params[[2]]$id, lower = params[[2]]$lower, upper = params[[2]]$upper, learnername = learnername,
               default = params[[2]]$default, stpsize = 0.0025
            ),
            addNumericParam(
               id = params[[3]]$id, lower = params[[3]]$lower, upper = params[[3]]$upper, learnername = learnername,
               default = params[[3]]$default, stpsize = 1
            ),
            actionButton(inputId = paste0(learnername, "ChangeParams"), label = "Change Parameters", style = "float: right;")
         )
      }
   } else if (grepl("svm", learnerobject$Learner$id, fixed = TRUE)) {
      params <- getAvailableParams(algorithm = "supportvm", learnerobject = learnerobject)
      if (grepl("threshold", learnerobject$Learner$id)) {
         parameterui <- tagList(
            # sigmoid kernel removed for explanatory reasons
            addFactorParam(id = params[[1]]$id, levels = c("radial", "polynomial", "linear"), learnername = learnername, default = params[[1]]$default),
            addNumericParam(
               id = params[[2]]$id, lower = params[[2]]$lower, upper = params[[2]]$upper, learnername = learnername,
               default = params[[2]]$default, stpsize = 0.1
            ),
            uiOutput(outputId = paste0(learnername, "KernelParam", "kernel")), # depending on selected kernel, different hyperparameters are available
            addNumericParam(id = params[[length(params)]]$id, lower = 0, upper = 1, learnername = learnername, default = 0.5, stpsize = 0.1),
            actionButton(inputId = paste0(learnername, "ChangeParams"), label = "Change Parameters", style = "float: right;")
         )
      } else {
         parameterui <- tagList(
            # sigmoid kernel removed for explanatory reasons
            addFactorParam(id = params[[1]]$id, levels = c("radial", "polynomial", "linear"), learnername = learnername, default = params[[1]]$default),
            addNumericParam(
               id = params[[2]]$id, lower = params[[2]]$lower, upper = params[[2]]$upper, learnername = learnername,
               default = params[[2]]$default, stpsize = 0.1
            ),
            uiOutput(outputId = paste0(learnername, "KernelParam", "kernel")), # depending on selected kernel, different hyperparameters are available
            actionButton(inputId = paste0(learnername, "ChangeParams"), label = "Change Parameters", style = "float: right;")
         )
      }
   } else if (grepl("xgboost", learnerobject$Learner$id, fixed = TRUE)) {
      params <- getAvailableParams(algorithm = "xgboost", learnerobject = learnerobject)
      if (grepl("threshold", learnerobject$Learner$id)) {
         parameterui <- tagList(
            #ETA 
            addNumericParam(id = params[[1]]$id, lower = params[[1]]$lower, upper = params[[1]]$upper, learnername = learnername, default = params[[1]]$default, stpsize = 0.1),
            #Max Depth
            addNumericParam(id = params[[2]]$id, lower = params[[2]]$lower, upper = params[[2]]$upper, learnername = learnername, default = params[[2]]$default, stpsize = 1),
            #nrounds
            addNumericParam(id = params[[3]]$id, lower = params[[3]]$lower, upper = params[[3]]$upper, learnername = learnername, default = params[[3]]$default, stpsize = 1),
            #colsample bytree
            addNumericParam(id = params[[4]]$id, lower = params[[4]]$lower, upper = params[[4]]$upper, learnername = learnername, default = params[[4]]$default, stpsize = 0.1),
            #Booster
            addFactorParam(id = params[[5]]$id, levels = c("gblinear", "gbtree", "dart"), learnername = learnername, default = params[[5]]$default),
            addNumericParam(id = params[[length(params)]]$id, lower = 0, upper = 1, learnername = learnername, default = 0.5, stpsize = 0.1),
            actionButton(inputId = paste0(learnername, "ChangeParams"), label = "Change Parameters", style = "float: right;")
         )
      } else {
         parameterui <- tagList(
            addNumericParam(id = params[[1]]$id, lower = params[[1]]$lower, upper = params[[1]]$upper, learnername = learnername, default = params[[1]]$default, stpsize = 0.1),
            addNumericParam(id = params[[2]]$id, lower = params[[2]]$lower, upper = params[[2]]$upper, learnername = learnername, default = params[[2]]$default, stpsize = 1),
            addNumericParam(id = params[[3]]$id, lower = params[[3]]$lower, upper = params[[3]]$upper, learnername = learnername, default = params[[3]]$default, stpsize = 1),
            addNumericParam(id = params[[4]]$id, lower = params[[4]]$lower, upper = params[[4]]$upper, learnername = learnername, default = params[[4]]$default, stpsize = 0.1),
            addFactorParam(id = params[[5]]$id, levels = c("gblinear", "gbtree", "dart"), learnername = learnername, default = params[[5]]$default),
            actionButton(inputId = paste0(learnername, "ChangeParams"), label = "Change Parameters", style = "float: right;")
         )
      }
   }
     else if (grepl("log_reg", learnerobject$Learner$id, fixed = TRUE)) {
        params <- getAvailableParams(algorithm = "log_reg", learnerobject = learnerobject)
        if (grepl("threshold", learnerobject$Learner$id)) {
          parameterui <- tagList(
            addNumericParam(id = params[[length(params)]]$id, lower = 0, upper = 1, learnername = learnername, default = 0.5, stpsize = 0.1),
            actionButton(inputId = paste0(learnername, "ChangeParams"), label = "Change Parameters", style = "float: right;")
          )
        }
   }
   return(parameterui)
}

# make the overview for each learner
makeLearnerOvTab <- function(learnerobject) {
   learnerov <- tagList(
      wellPanel(
         fluidRow(
            column(
               12,
               h5("Learner Information", style = "font-weight: bold;"),
               makeOverviewUi(learnerobject = learnerobject)
            )
         )
      )
   )
}

# place overview and learner together in a tab
makeLearnerParamTab <- function(learnerobject, learnername) {
   # twoclass classif cannot change predict type due to pipeops
   if (!identical(currenttask$task$properties, character(0)) && currenttask$task$properties == "twoclass") {
      change_predict_type <- tagList()
   } else {
      change_predict_type <- tagList(
         hr(style = "border-color: #3e3f3a;"),
         fluidRow(
            column(
               4,
               h5("Change Predict Type")
            ),
            column(
               4,
               selectInput(
                  inputId = paste0(learnername, "PredictTypeChoice"), label = NULL, choices = learnerobject$Learner$predict_types,
                  selected = learnerobject$Learner$predict_type
               )
            ),
            column(
               4,
               actionButton(inputId = paste0(learnername, "PredictTypeChange"), label = "Change", style = "float: right;")
            )
         )
      )
   }
   learnerparams <- tagList(
      wellPanel(
         fluidRow(
            column(
               12,
               h5("Learner Parameters", style = "font-weight: bold;"),
               makeParamUi(learnerobject = learnerobject, learnername = learnername),
               ),
         ),
         change_predict_type
      )
   )
   return(learnerparams)
}


# # create GraphLearner object
# # for twoclass the threshold-po is added
# # if xgboost is selected the factor variables will be converted into numerals
# # furthermore ordered variables will also be converted to integers
# createGraphLearner_old_alex <- function(selectedlearner) {
#    graph <- Graph$new()
#    if (!isTRUE(currenttask$task$properties == "twoclass")) {
#       learner <- po("learner", lrn(input[[selectedlearner]]))
#       graph$add_pipeop(learner)
#    } else {
#       learner <- po("learner", lrn(input[[selectedlearner]], predict_type = "prob"))
#       graph$add_pipeop(learner)
#       graph <- graph %>>% po("threshold")
#    }
#    if (any(grepl("factor", unique(currenttask$task$feature_types$type))) && !any(grepl("factor", lrn(input[[selectedlearner]])$feature_types))) {
#       graph <- po("encode", method = "treatment", affect_columns = selector_type("factor")) %>>% graph
#    }
#    if (any(grepl("ordered", unique(currenttask$task$feature_types$type))) && !any(grepl("ordered", lrn(input[[selectedlearner]])$feature_types))) {
#       graph <- po("colapply", applicator = as.integer, affect_columns = selector_type("ordered")) %>>% graph
#    }
#    return(as_learner(graph))
# }


createGraphLearner <- function(selectedlearner) {
  learner_algo <- input[[selectedlearner]]
  if (!isTRUE(currenttask$task$properties == "twoclass")) {
    if (learner_algo == "classif.rpart" | learner_algo == "regr.rpart") {
      #only decision trees are able to use keep_model = T | used for visualization
      learner <- lrn(input[[selectedlearner]], keep_model = TRUE, label = "")} 
    else {
      learner <- lrn(input[[selectedlearner]], label = "")} 
  } 
  else { # ...otherwise predict_type = "prob" is set and a threshold po added below
    if (learner_algo == "classif.rpart" | learner_algo == "regr.rpart") {
      learner <- lrn(input[[selectedlearner]], predict_type = "prob", keep_model = TRUE, label = "")
    }
    else {
      learner <- lrn(input[[selectedlearner]], predict_type = "prob", label = "")
    }
  }
  if(input[["Task_robustify"]]){
    impm <- NULL 
    if(input[["impute_missings"]] == "TRUE") {impm <- TRUE}
    if(input[["impute_missings"]] == "FALSE") {impm <- FALSE}
    
    ftn <- NULL 
    if(input[["factors_to_numeric"]] == "TRUE") {ftn <- TRUE}
    if(input[["factors_to_numeric"]] == "FALSE") {ftn <- FALSE}

    graph <- pipeline_robustify(currenttask$task, learner,
                                 impute_missings    = impm,
                                 factors_to_numeric = ftn,
                                 max_cardinality    = input[["max_cardinality"]],
                                 ordered_action     = input[["ordered_action"]],
                                 character_action   = input[["character_action"]],
                                 POSIXct_action     = input[["POSIXct_action"]]) %>>% learner
       
    plot(graph)
  } else graph <- as_graph(po("learner", learner))
  if (isTRUE(currenttask$task$properties == "twoclass")) graph <- graph %>>% po("threshold")
  return(as_learner(graph))
}


# add observers and others to generate the tabs depending on the needs of the user
makeLearner <- function(learnerobject, learnername, trigger, selectedlearner, learnerparamoutput, learnerovoutput) {
   observeEvent(input[[trigger]], {
       learnerobject$Learner <- createGraphLearner(selectedlearner)
      learnerobject$Learner_Name <- input[[selectedlearner]]
      # learnerobject$Learner <- mlr_learners$get(input[[selectedlearner]])
      LearnerMeta$Learner_Avail <- unique(sort(c(LearnerMeta$Learner_Avail, learnername)))
      learnerobject$Hash <- learnerobject$Learner$hash
      output[[learnerparamoutput]] <- renderUI({
         makeLearnerParamTab(learnerobject = learnerobject, learnername = learnername)
      })
      output[[learnerovoutput]] <- renderUI({
         makeLearnerOvTab(learnerobject = learnerobject)
      })
      # resetting the trained learner on learner creation
      reset_single_trained_learner(learnername)
   })

   observe({
      if (!is.null(learnerobject$Learner)) {
         learnerobject$Overview <- getLearnerOverview(learnerobject = learnerobject)
      }
      learnerobject$Hash <- learnerobject$Learner$hash
   })

   # missing reactivity with R6-classes requires another execution of getLearnerOverview
   observeEvent(input[[paste0(learnername, "PredictTypeChange")]], {
      learnerobject$Learner$predict_type <- input[[paste0(learnername, "PredictTypeChoice")]]
      learnerobject$Overview <- getLearnerOverview(learnerobject = learnerobject)
      learnerobject$Hash <- learnerobject$Learner$hash
   })
   
   # observerevent for label button: implemented because of interactivity.So that a user knows it has been updated 
   observeEvent(input[[paste0(learnerobject$Learner_Name, "LabelChange")]], {
     learnerobject$Learner$label <- input[[paste0(learnerobject$Learner_Name, "LabelChoice")]]
     showNotification("Label updated successfully", duration = 3, id = "LabelChangeSuccess", type = "message")
   })

   # kernel params for svm
   output[[paste0(learnername, "KernelParam", "kernel")]] <- renderUI({

      # if statement necessary to avoid strange shiny internal warning about empty condition when generating HTML
      if (input[[selectedlearner]] %in% c("classif.svm", "regr.svm")) {
         getKernelParams(
            learnerobject = learnerobject, learnername = learnername,
            selectedkernel = input[[paste0(learnername, "factor", learnerobject$Learner_Name, ".kernel")]]
         )
      }
   })

   # # To-Do: get a prettier solution
   observeEvent(input[[paste0(learnername, "ChangeParams")]], {
      paramlist <- list()
      invalidparams <- NULL
     
      for (i in learnerobject$Params) {
         if(i$cls == "ParamFct") {
           currentinput <- input[[paste0(learnername, "factor")]]
         }
         else {
           currentinput <- input[[paste0(learnername, "Param", i$id)]]
         }
         # validate input value with 2 overall if statements 
         # on Windows and Linux Shiny sends NA (empty) inputs differently
         # Windows translates to 0 whereas Linux keeps as NA
         # hence we check if the input is NA separately
         if (is.null(currentinput) || is.na(currentinput)) {
           invalidparams <- c(invalidparams, i$id)
         }

         if (!is.null(currentinput) && !is.na(currentinput)) {
            if ((!is.na(learnerobject$Learner$param_set$params[id==i$id]$upper) &&
                 currentinput > learnerobject$Learner$param_set$params[id==i$id]$upper) ||
                (!is.na(learnerobject$Learner$param_set$params[id==i$id]$lower) &&
                 currentinput < learnerobject$Learner$param_set$params[id==i$id]$lower) ||
                (i$id == "classif.ranger.mtry" && currentinput > length(currenttask$task$feature_names)) ||
                (i$id == "threshold.thresholds" && currentinput > 1) ||
                (i$id == "threshold.thresholds" && currentinput < 0)) 
                {
                  invalidparams <- c(invalidparams, paste0(learnername, "Param", i$id))
            }
            else {
               paramlist[[i$id]] <- currentinput
            }
         }
      }
 
      if(!is.null(invalidparams)){
        shinyalert(title = "Notification",
                text = paste("(Empty or Invalid Parameter Input:) It seems that you tried to set parameter(s): ",
                             paste(unlist(invalidparams), collapse = ', '),
                             " that are left empty or not within their parameter range. The default value for the parameter(s) is used instead."),
                animation = FALSE, closeOnClickOutside = TRUE)
      }
        
      #TODO: need to find better solution to add factor params to paramlist
      # a solution could be to distinguish between a display name and the internal one
      # so the ChangeParams-Routine could be used

      svm_kernel <- c("radial", "polynomial", "linear")

      if (grepl("xgboost", learnerobject$Learner_Name)) {
         if (input[[paste0(learnername, "factor")]] %in% xgboost_booster) {
            paramlist[[paste0(learnerobject$Learner_Name, ".booster")]] <- input[[paste0(learnername, "factor",id)]]
         }
      }

      if (grepl("svm", learnerobject$Learner_Name)) {
         if (input[[paste0(learnername, "factor")]] %in% svm_kernel) {
            paramlist[[paste0(learnerobject$Learner_Name, ".kernel")]] <- input[[paste0(learnername, "factor")]]
         }
      }

      # explicit defaults for svm type to be used
      if (grepl("classif.svm", learnerobject$Learner_Name)) {
         paramlist[[paste0(learnerobject$Learner_Name, ".", "type")]] <- "C-classification"
      } else if (grepl("regr.svm", learnerobject$Learner_Name)) {
         paramlist[[paste0(learnerobject$Learner_Name, ".", "type")]] <- "eps-regression"
      }

     # check for any parameters that are to be overwritten by paramlist
     if(length(learnerobject$Learner$param_set$values) > 0){
       for (pn in names(learnerobject$Learner$param_set$values)){
         if (any(pn == names(paramlist))) {learnerobject$Learner$param_set$values[[pn]] <- NULL}
       }
     }

      #old: learnerobject$Learner$param_set$values <- paramlist # update hyperparameter values of current learner
      learnerobject$Learner$param_set$set_values(.values=paramlist) # update hyperparameter values of current learner
      # is new learnerobject$Learner$param_set$values still compatible with (unchanged) rest of learnerobject$Learner$param_set?
      # learnerobject$Overview <- getLearnerOverview(learnerobject = learnerobject)
      learnerobject$Hash <- learnerobject$Learner$hash

      # resetting trained learner when params change
      reset_single_trained_learner(learnername)
   })
}


# TO-DO: ugly code, think of better solution eg add simple for loop
makeLearner(
   learnerobject = Learner1, learnername = "Learner1", trigger = "Learner_Create1", selectedlearner = "Learner_Learner1",
   learnerparamoutput = "Learner1_tab", learnerovoutput = "Learner1_ov"
)

makeLearner(
   learnerobject = Learner2, learnername = "Learner2", trigger = "Learner_Create2", selectedlearner = "Learner_Learner2",
   learnerparamoutput = "Learner2_tab", learnerovoutput = "Learner2_ov"
)

makeLearner(
   learnerobject = Learner3, learnername = "Learner3", trigger = "Learner_Create3", selectedlearner = "Learner_Learner3",
   learnerparamoutput = "Learner3_tab", learnerovoutput = "Learner3_ov"
)

makeLearner(
   learnerobject = Learner4, learnername = "Learner4", trigger = "Learner_Create4", selectedlearner = "Learner_Learner4",
   learnerparamoutput = "Learner4_tab", learnerovoutput = "Learner4_ov"
)

makeLearner(
   learnerobject = Learner5, learnername = "Learner5", trigger = "Learner_Create5", selectedlearner = "Learner_Learner5",
   learnerparamoutput = "Learner5_tab", learnerovoutput = "Learner5_ov"
)

makeLearner(
   learnerobject = Learner6, learnername = "Learner6", trigger = "Learner_Create6", selectedlearner = "Learner_Learner6",
   learnerparamoutput = "Learner6_tab", learnerovoutput = "Learner6_ov"
)

makeLearner(
   learnerobject = Learner7, learnername = "Learner7", trigger = "Learner_Create7", selectedlearner = "Learner_Learner7",
   learnerparamoutput = "Learner7_tab", learnerovoutput = "Learner7_ov"
)

# reset Learners when Task changes
observeEvent(currenttask$task, {
   Learner1$Learner <- NULL
   Learner2$Learner <- NULL
   Learner3$Learner <- NULL
   Learner4$Learner <- NULL
   Learner5$Learner <- NULL
   Learner6$Learner <- NULL
   Learner7$Learner <- NULL
   LearnerMeta$Learner_Avail <- NULL
})

# reactive values for task
currenttask <- reactiveValues(task = NULL, overview = NULL, target = NULL, featNames = NULL, featTypes = NULL, positive = NULL, tableOptions = NULL)
# in case a feature gets dropped make sure to only include the same features when predicting new data
features_to_use <- reactiveValues(features = NULL)
# used for visualization puropses
originalTask <- NULL

# render sidebarPanel depending on input for Task
observe({
  if (input$Task_backend == "iris" || input$Task_backend == "mtcars" || input$Task_backend == "german_credit") {
    currenttask$task <- mlr_tasks$get(input$Task_backend)
  }
  else if (is.null(data$traindata) && input$Task_backend == "imported training data" ) {
    shinyalert(title = "Task Creation", text = userhelp[["Task Creation"]], closeOnClickOutside = TRUE, animation = FALSE)
  }
  else if (!is.null(data$traindata) && input$Task_backend == "imported training data") {
    output$Task_make_id <- renderUI({
      textInput(inputId = "Task_id", label = h5("Task ID"), value = "my_task")
    })
    choices <- colnames(data$traindata)
    output$Task_make_target <- renderUI({
      selectInput(inputId = "Task_target", label = h5("Task Target"), choices = choices,
                  selected = choices[length(choices)])
    })
    output$Task_make_task <- renderUI({
      div(style = "display:inline-block; width:100%; text-align: center;",
          actionButton(inputId = "Task_make", label = "Create Task", icon = icon("bookmark"))
      )
    })
  }
})

observeEvent(currenttask$task,{
  reset_trained_learner_list()
  output$plot_visualization <- renderPlot({})
})

observe({
  toggle(id = "Task_target", condition = (input$Task_backend == "imported training data"))
  toggle(id = "Task_id", condition = (input$Task_backend == "imported training data"))
  toggle(id = "Task_make", condition = (input$Task_backend == "imported training data"))
})

# decide whether it is a classification or regression task
observeEvent(input$Task_make, {
  currenttask$target <- data$traindata[, input$Task_target]

  if (is.numeric(currenttask$target)) {
    currenttask$task <- TaskRegr$new(id = input$Task_id, backend = data$traindata, target = input$Task_target)
  }
  else if (is.factor(currenttask$target)) {
    currenttask$task <- TaskClassif$new(id = input$Task_id, backend = data$traindata, target = input$Task_target)
  }
  else {
    shinyalert(title = "Target Selection",
               text = userhelp[["Task Creation Target"]], closeOnClickOutside = TRUE, animation = FALSE)
  }
})

# Task Summary
observe({
  # get bad features
  # To-DO: What to do when prediction data have unsupported features? -> for preprocessing later on
  allfeat <- currenttask$task$feature_types
  bad <- c("POSIXct", "complex", "Date")
  badfeat <- allfeat[which(allfeat[, 2]$type %in% bad), ]$id
  features_to_use$features <- allfeat[!badfeat,]$id
  # deactivate unwanted features
  currenttask$task$select(cols = features_to_use$features)

  if (length(badfeat)) {
    shinyalert(title = "Features Dropped", text = userhelp[["Features Dropped"]], closeOnClickOutside = TRUE, animation = FALSE)
  }

  ### mlr task is R6 Object, Shiny cannot see, when this object's state changes cause its modified in place
  ### to ensure that the table still updates when the features are removed later on, assign it an extra reactive value
  currenttask$featTypes <- currenttask$task$feature_types
  currenttask$featNames <- currenttask$task$feature_names
  if (!identical(currenttask$task$properties, character(0)) && currenttask$task$properties == "twoclass") {
    currenttask$positive <- currenttask$task$positive
  }
  # add positive label if twoclass
  currenttask$overview <- list(
    task_id <- currenttask$task$id,
    task_property = currenttask$task$properties,
    task_type = currenttask$task$task_type,
    cols = currenttask$task$ncol,
    observations = currenttask$task$nrow,
    target = c(currenttask$task$target_names),
    features = currenttask$featTypes
  )
})

# datatable options
observe({
  if (nrow(currenttask$featTypes) > 4) {
    currenttask$tableOptions <- list(paging = FALSE, searching = FALSE,
                   bInfo = FALSE, ordering = FALSE, width = "250px",
                   scrollY = "130px")
  }
  else {
    currenttask$tableOptions <- list(paging = FALSE, searching = FALSE,
                                     bInfo = FALSE, ordering = FALSE, width = "250px")
  }
})

#### angepasst aus shinymlr
addOverviewLineTask = function(title, body) {
  fluidRow(
    column(4, h5(title)),
    column(8, h5(body))
  )
}

printTaskOverviewUI = function() {
  tagList(
            h5("Task Overview", style = " font-weight: bold;"),
            addOverviewLineTask("Supervised Task: ", paste(currenttask$overview[[2]], currenttask$overview[[3]], sep = " ")),
            addOverviewLineTask("Task ID: ", currenttask$overview[[1]]),
            addOverviewLineTask("Data: ", paste(currenttask$overview[[4]], "Variables with",
                                            currenttask$overview[[5]], "Observations", sep = " ")),
            addOverviewLineTask("Target: ", currenttask$overview[[6]]),
            if (!identical(currenttask$task$properties, character(0)) && currenttask$task$properties == "twoclass") {
            addOverviewLineTask("Positive Class: ", currenttask$positive)
              },
            addOverviewLineTask("Features: ", renderDataTable(expr = as.data.table(currenttask$overview[[7]]), rownames = FALSE,
                                                          options = currenttask$tableOptions)
                            )
  )
}
###

output$Task_overview <- renderPrint({
  printTaskOverviewUI()
})



# Task processing

observeEvent(input$Task_feat_deactivate, {
    #updatedfeat <- setdiff(currenttask$task$feature_names, input$Task_feature)
    #currenttask$task$select(cols = updatedfeat)
    currenttask$task$select(cols = input$Task_feature)
  
    ## here we need to update currenttask$features, so that Shiny recognizes that the R6- task - object has changed
    currenttask$featTypes <- currenttask$task$feature_types
    currenttask$featNames <- currenttask$task$feature_names
})

observeEvent(input$Task_change_pos_class, {
  currenttask$task$positive <- input$Positive_class
  ## here we need to update currenttask$positive, so that Shiny recognizes that the R6- task - object has changed
  currenttask$positive <- currenttask$task$positive
})

observeEvent(input$Task_robustify, {
  if(!input[["Task_robustify"]]){
    shinyalert(title = "Notification",
               text = "Robustify data preprocessing disabled. 
                       Note that this might lead to an error 
                       when training a learner if the chosen
                       learner can not deal with all variable types 
                       in the original data.",
               animation = FALSE, 
               closeOnClickOutside = TRUE,
               className="alert-info",)
  }
})



printTaskProcessingUI <- function(){
  tagList(
    h5("Task Processing", style = "font-weight: bold;"),
    if (!identical(currenttask$task$properties, character(0)) && currenttask$task$properties == "twoclass") {
      fluidRow(column(4,
                      h5('Set Positive Class:')),
               column(4,selectizeInput(inputId = "Positive_class", label = NULL,
                                       choices = c(currenttask$task$class_names),
                                       options = list(
                                         placeholder = 'Nothing selected',
                                         onInitialize = I('function() { this.setValue(""); }')
                                       ),
                                       multiple = FALSE)),
               column(4, actionButton(inputId = "Task_change_pos_class", label = "Change", style = "float: right;")))
    },
    fluidRow(
      column(4, h5("Select Features: ")),
      column(4,  pickerInput("Task_feature",
                             choices = c(currenttask$featNames),
                             multiple = TRUE,
                             selected = c(currenttask$featNames),
                             options = pickerOptions(
                               #  list(
                               #   placeholder = 'Nothing selected',
                               #   onInitialize = I('function() { this.setValue(""); }')
                               # )
                               list(`actions-box` = TRUE)
                               )
                             )
             ),
      #now select instead of dtop / deactivate
      column(4, actionButton(inputId = "Task_feat_deactivate", label = "Select", style = "float: right;"))
    ),
    fluidRow(
      column(4, h5("Robustify: ")),
      column(8, checkboxInput(inputId = "Task_robustify", label = "apply mlr3 robustify preprocessing to data", value = TRUE),
                conditionalPanel(condition = "input[[\"Task_robustify\"]] == true",
                                 checkboxInput("robustify_details", label = "Show detailed options for robustification", value = FALSE)),
                conditionalPanel(condition = "input[[\"robustify_details\"]] == true",
                                 selectInput("impute_missings", "impute_missings", list("NULL" = "NULL", "TRUE" = "TRUE", "FALSE" = "FALSE"), selected = "NULL")),
                conditionalPanel(condition = "input[[\"robustify_details\"]] == true",
                                 selectInput("factors_to_numeric", "factors_to_numeric", list("NULL" = "NULL", "TRUE" = "TRUE", "FALSE" = "FALSE"), selected = "NULL")),
                conditionalPanel(condition = "input[[\"robustify_details\"]] == true",
                                 numericInput("max_cardinality", label = "max_cardinality", value = 1000, min = 2)),
                conditionalPanel(condition = "input[[\"robustify_details\"]] == true",
                                 selectInput("ordered_action", "ordered_action", 
                                             list("factor" = "factor", "factor!" = "factor!", "matrix" = "matrix", "matrix!" = "matrix!",
                                                  "ignore" = "ignore", "ignore!" = "ignore!"), selected = "factor")),
                conditionalPanel(condition = "input[[\"robustify_details\"]] == true",
                                 selectInput("character_action", "character_action", 
                                             list("factor" = "factor", "factor!" = "factor!", "matrix" = "matrix", "matrix!" = "matrix!",
                                                  "ignore" = "ignore", "ignore!" = "ignore!"), selected = "factor")),
                conditionalPanel(condition = "input[[\"robustify_details\"]] == true",
                                 selectInput("POSIXct_action", "POSIXct_action", 
                                             list("numeric" = "numeric", "numeric!" = "numeric!", "datefeatures" = "datefeatures", "datefeatures!" = "datefeatures!",
                                                  "ignore" = "ignore", "ignore!" = "ignore!"), selected = "factor"))
             
             )
    )
    
  )

}


output$Task_processing <- renderUI({
  printTaskProcessingUI()
})

render_visualization_plot <- function(task) {
  output$plot_visualization <- renderPlot({
    autoplot(task, input$Plot_Type)
    })
  }

observeEvent(input$action_visualize, {
  temp_task <- originalTask$clone(deep = TRUE)

  if (is.null(input$Features_Viz)) {
    #exit code execution if no feature is selected and reset selected to default
    updatePickerInput(session = session, inputId="Features_Viz", selected=originalTask$feature_names)
    shinyalert(
      title = "Warning",
      text = "You need to select Features for Visualization.",
      animation = FALSE,
      showConfirmButton = TRUE,
      className="alert-warning",
    )
    return()
  }
  task <- temp_task$select(cols = input$Features_Viz)

  output$show_viz <- reactive(TRUE)
  outputOptions(output, "show_viz", suspendWhenHidden = FALSE)

  if (task$nrow > 5000 | length(task$feature_names) > 5) {
    shinyalert(
      title = "Information",
      text = "Computation time for the plot might take long, 
      because there are many observations or variables in the Data Backend.
      This might also affect readability of the plot.",
      animation = FALSE,
      showCancelButton = TRUE,
      showConfirmButton = TRUE,
      className="alert-info",
      callbackR = function(x) {if (x == TRUE) {render_visualization_plot(task)}})
  }
  else {
    render_visualization_plot(task)
    }
})

printTaskVisualizeUI <- function(){
  # make a copy of the task so the vizualisation is independent
  originalTask <<- currenttask$task$clone(deep = TRUE)
  plot_features = originalTask$feature_names
  plot_choices = c("target", "duo", "pairs")
  if (originalTask$task_type == "regr") {
    plot_choices = plot_choices[plot_choices != "duo"]
  }
  tagList(
    h5("Visualization of Data", style = "font-weight: bold;"),
    fluidRow(
      column(4, h5("Select Plot Type:")),
      column(4, pickerInput("Plot_Type",
                             choices = plot_choices,
                             selected = "pairs")),
      column(4, actionButton(inputId = "action_visualize", label = "Create Visualization", icon = icon("hammer")))),
      conditionalPanel(condition = "input[[\"Plot_Type\"]] != 'target'", 
        fluidRow(
        column(4, h5("Select Features for Visulization:")),
        column(4, pickerInput("Features_Viz",
                                choices = originalTask$feature_names,
                                multiple = TRUE,
                                selected = originalTask$feature_names)))),
    conditionalPanel(condition="input.action_visualize != 0 && output.show_viz == true", plotOutput(outputId = "plot_visualization"))
  )
}

observeEvent(input$Plot_Type, {
  output$show_viz <- reactive(FALSE)
  outputOptions(output, "show_viz", suspendWhenHidden = FALSE)
  output$plot_visualization <- renderPlot({})
})

output$Task_visualize <- renderUI({
  printTaskVisualizeUI()
})

server <- function(input, output, session) {
  server_files = list.files(path = "./server")
  server_files = paste0("server/", server_files)
  for (i in seq_along(server_files)) {
    source(server_files[i], local = TRUE)
  }
  options(shiny.maxRequestSize=1000*1024^2)
  observeEvent(input$Help, {
    if (req(input$navbar) == "1. Data") {
      showModal(
        modalDialog(
          title = h2("Data Import & General Information", style = "text-align: center;"),
          h4("General:"),
          HTML(userhelp[["Data"]][1]),
          h4("Description:"),
          HTML(userhelp[["Data"]][2]),
          easyClose = TRUE,
          footer = div(style = "display:inline-block;width:100%;text-align: center;",
                       modalButton('OK'))
          )
      )
    }
    else if (req(input$navbar) == "2. Task") {
      showModal(
        modalDialog(
          title = h2("Task Creation", style = "text-align: center;"),
          h4("Description:"),
          HTML(userhelp[["Task"]][1]),
          hr(),
          h4("Functionalities:"),
          HTML(userhelp[["Task"]][2]),
          easyClose = TRUE,
          footer = div(style = "display:inline-block;width:100%;text-align: center;",
                       modalButton('OK')))
      )
    }
    else if (req(input$navbar) == "3. Learner") {
      showModal(
        modalDialog(
          title = h2("Learner Selection", style = "text-align: center;"),
          h4("Description:"),
          HTML(userhelp[["Learner"]][1]),
          hr(),
          h4("Functionalities:"),
          HTML(userhelp[["Learner"]][2]),
          HTML("</br>", "</br>"),
          HTML(userhelp[["Learner"]][3]),
          HTML("</br>", "</br>"),
          HTML(userhelp[["Learner"]][4]),
          HTML("<br/>", "<br/>"),
          HTML(userhelp[["Learner"]][5]),
          HTML("<br/>", "<br/>"),
          HTML(userhelp[["Learner"]][6]),
          easyClose = TRUE,
          footer = div(style = "display:inline-block;width:100%;text-align: center;",
                       modalButton('OK')))
      )
    }
    else if (req(input$navbar) == "4. Train & Evaluate") {
      switch(Help$Tracker,
             {showModal(
               modalDialog(
                 title = h2("Basic Model Training & Evaluation", style = "text-align: center;"),
                 h4("Description:"),
                 HTML(userhelp[["Evaluate"]][1]),
                 hr(),
                 h4("Functionalities:"),
                 HTML(userhelp[["Evaluate"]][2]),
                 easyClose = TRUE,
                 footer = div(style = "display:inline-block;width:100%;text-align: center;",
                              modalButton('OK')))
             )},
             {
               showModal(
                 modalDialog(
                   title = h2("Resampling", style = "text-align: center;"),
                   h4("Description:"),
                   HTML(userhelp[["Resample"]][1]),
                   hr(),
                   h4("Functionalities:"),
                   HTML(userhelp[["Resample"]][2]),
                   HTML("</br>", "</br>"),
                   HTML(userhelp[["Resample"]][3]),
                   HTML("</br>", "</br>"),
                   HTML(userhelp[["Resample"]][4]),
                   HTML("<br/>", "<br/>"),
                   HTML(userhelp[["Resample"]][5]),
                   easyClose = TRUE,
                   footer = div(
                     style = "display:inline-block;width:100%;text-align: center;",
                     modalButton('OK')
                   )
                 )
               )
               }
             )
    }
    else if (req(input$navbar) == "5. Benchmarking") {
      showModal(
        modalDialog(
          title = h2("Benchmarking", style = "text-align: center;"),
          h4("Description:"),
          HTML(userhelp[["Benchmark"]][1]),
          hr(),
          h4("Functionalities:"),
          HTML(userhelp[["Benchmark"]][2]),
          easyClose = TRUE,
          footer = div(style = "display:inline-block;width:100%;text-align: center;",
                       modalButton('OK')))
      )
    }
    else if (req(input$navbar) == "6. Predict") {
      showModal(
        modalDialog(
          title = h2("Prediction For New Data", style = "text-align: center;"),
          h4("Description:"),
          HTML(userhelp[["Predict"]][1]),
          hr(),
          h4("Functionalities:"),
          HTML(userhelp[["Predict"]][2]),
          easyClose = TRUE,
          footer = div(style = "display:inline-block;width:100%;text-align: center;",
                       modalButton('OK')))
      )
    }
    else if (req(input$navbar) == "7. Explain") {
      showModal(
        modalDialog(
          title = h2("Explain your Learners", style = "text-align: center;"),
          h4("Description:"),
          HTML(userhelp[["Explain"]][1]),
          hr(),
          h4("Functionalities:"),
          HTML(userhelp[["Explain"]][2]),
          easyClose = TRUE,
          footer = div(style = "display:inline-block;width:100%;text-align: center;",
                       modalButton('OK')))
      )
    }
  })
}

library(shiny)
library(mlr3)
library(mlr3learners)
library(mlr3pipelines)
library(mlr3viz)
library(DALEX)
library(DALEXtra)
library(Metrics)
library(plyr)
library(dplyr)
library(DT)
library(shinydashboard)
library(shinyjs)
library(shinyWidgets)
library(shinyalert)
library(data.table)
library(readxl)
library(stringr)
library(purrr)
library(stringr)
library(bslib)
library(haven)
library(igraph)
library(xgboost)
library(ranger)
library(ggparty)
library(GGally)
library(e1071)


requireNamespace("mlr3measures")

userhelp <- list(Data = c(paste("This app let's you conduct the basic steps of a machine learning workflow using your own data.",
                                "You can navigate over the different sections by clicking on each tab. They are chronologically ordered.",
                                "To get more information on the functionalities and purpose of each section, click on the questionmark in the rop-right corner.",
                                "Start by importing a dataset.",
                                "Then define a task (the problem to be solved) in the 'task' tab. Example tasks are already provided.",
                                "Select different learners (algorithms) in the 'learner' tab and train and evaluate a model in 'train & evaluate'.",
                                "Resampling strategies can be applied in a sub-section of 'train & evaluate'.",
                                "Alternatively, different learners can be compared in a benchmark.",
                                "Use the final model to make a prediction on new data in the 'predict' tab. ",
                                sep = " "
                          ),
                          paste("Here, you can import a dataset that you want to train your machine learning model on.",
                                "On the right-hand side an overview will be given of its composition.",
                                "The accepted file formats are .txt, .csv and .xlsx'.",
                                "Ensure that a header row is present in the dataset or else deactivate the checkbox 'Header'.",
                                sep = " ")),
                 "Task Creation" = c("A training dataset must be imported before using it as data backend for a task."),
                 "Task Creation Target" = c(paste("The target variable needs to be of type factor (categorical) or numeric (a number).",
                                                  "If unsure you can have a look at the training data in the DATA tab.")),
                 "Features Dropped" = c(paste("Your dataset contains unsupported features of type 'POSIXct' (Date and Time),",
                                              "'complex' (a complex number) or 'Date'.",
                                              "These features will be disabled and not used to train your model.")),
                 Task = c(paste("A task is an object to store the training dataset as backend and additional information about it as meta information.",
                                "These are needed due to the particular requirements of a machine-learning problem and e.g. include the target variable and specific roles for other variables.",
                                "Moreover, the meta information holds the task type such as a classification or a regression.",
                                "If the target variable is of type numeric, the task will be of type regression. If the target is a factor,",
                                "the task is a classification and can predict either a target with two levels (two class) or a target with multiple classes (multiclass).", sep = " "),
                          paste("Three examplary tasks are provided. Otherwise, select the imported training data and set a target name and a task ID.",
                                "On the right-hand side you can select features in case only a subset of variables available in the dataset should be included in the ML experiment.",
                                "This is useful to exclude variables that do not provide an information gain such as an ID or a feature with only one level over all observations.",
                                "To inspect the data, return to the 'Data' tab.",
                                "If it is a two class classification some evaluation metrics such as precision or recall look at 'positive' and 'negative' classes of the target variable.",
                                "If this needs changing, you can set the class that shall be seen as the positive one here.",
                                sep = " ")),

                 Learner = c(paste("Different machine-learning algorithms can be selected as 'learners' which",
                                   "provide an interface to the actual algorithm together wirth some meta information such as the predict type,",
                                   "and its current hyperparameter settings. For classification tasks predict types can be response or probability.",
                                   sep = " "),
                             paste("Currently, one can select the among algorithms: decision tree, random forest, xgboost, support vector machine.",
                                   "In addition logistic regression is available for classification and linear regression for regression.",
                                   "For each learner the most important hyperparameters can be specified under 'Learner Parameters' ",
                                   "in order to improve predictive power.",
                                   "The predict type can be changed to align with the requirements w.r.t. particular measures or desired usage of the model.",
                                   "For further information, visit the GitHub repository where all packages and algorithms are referenced.",
                                   sep = " "),
                             paste("Decision trees are adjustable via:",
                                   "minsplit - minimum number of observations in a node before performing a split,",
                                   "cp - larger complexity parameters > 0 prevents a split for small improvements,",
                                   "maxdepth - maximum depth of any node of the tree,", sep = "<br/>"),
                             paste("Random forests are adjustable via:",
                                   "num.trees - number of trees used for prediction,",
                                   "mtry - number of features that are considered for splitting a node,",
                                   "min.node.size - minimal node size to stop this node from splitting,",
                                   sep = "<br/>"),
                             paste("Support vector machines are adjustable via:",
                                   "kernel - a kernel function to quantify the similarity of two observations,",
                                   #"linear kernel - expects a linear relationship between a pair of observations and quantifies the similarity using standard correlation",
                                   #"polynomial kernel - fitting the sv classifier into a higher dimensional feature space",
                                   #"radial kernel - kernel with very local behaviour",
                                   "cost - cost of constraint violations (allowed missclassifications),",
                                   "gamma - defines how far the influence of an observation reaches (low: far; high: close),",
                                   "degree - a higher polynomial degree increases adaptivity to data,", sep = "<br/>"),
                             paste("xgboost is adjustable via:",
                                   "eta - controls the learning rate: scales the contribution of each tree by a factor < 1.
                                    A lower value for eta is more robust to overfitting but requires larger value of nrounds,",
                                   "max_depth - maximum depth of a tree,",
                                   "nrounds - maximum number of boosting iterations,",
                                   "colsample_bytree - subsample ratio of columns when constructing each tree,",
                                   "booster - which booster to use.",
                                   sep = "<br/>")),
                 Evaluate = c(paste("During the basic machine-learning workflow an algorithm is trained on a subset of the imported data, the training data,",
                                    "and evaluated on the remaining part of it, the test dataset.",
                                    "The target variable is predicted both for the training and test dataset in order to be able to compare different",
                                    "hyperparameter settings and take care of overfitting (loss of generalizability to new data).",
                                    "After predicting the target, a measure can be selected to score the performance of the trained model on both datasets.",
                                    "Alternatively, it is also possible to evaluate a learner using one of several resampling strategies such as holdout, cross-validation or bootstrap.",sep = " "),
                              paste("After creating learners in the 'learner'-tab, one learner can be selected for model training.",
                                    "The trained model serves to make a prediction for the target variable.",
                                    "Different measures are available for performance evaluation afterwards depending on the characteristics of the task and the learner.",
                                    "Classification metrics differ between two class vs multi class prediction problems. Certain measures require probabilities to be computed.",
                                    "This can be specified under Learner - Change Predict Type.",
                                    "<p>Further information on each measure can be found in the <a href='https://mlr3measures.mlr-org.com/reference/index.html'>mlr3 function reference</a>.</p>"
                                )),
                 Resample = c(paste("Resampling offers the possibility of training the same learner several times on different subsets of the",
                                    "training data.",
                                    "In doing so multipe models are generated, each differing slightly from the others.",
                                    "By evaluating the aggregated performance over all models, a better inference on the suitability",
                                    "of the algorithm and its hyperparameterset for the present machine learning problem",
                                    "can be made."),
                              paste("To start resampling choose a learner and a resampling strategy.",
                                    "The strategy can then be adjusted through its hyperparameters in the 'parameter settings'.",
                                    "Stratification can be used to make sure the ratio between the different values of the target is kept within each sample.",
                                    "After resampling, a combination of all generated models can be used to compute an overall prediction.",
                                    "The ResampleResult-object that mlr3 produces can be downloaded for further inspection.",
                                    "Finally, a measure can be used to compute the aggregated performance of the algorithm on given observations of the test sets.",
                                    sep = " "),
                              paste("A holdout strategy is the same as the training test split performed during the 'basic workflow'."),
                              paste("Cross validation splits the dataset in k groups of equal size.",
                                    "Each group serves as test set during one iteration while the others are used as training data.",
                                    "The number of iterations is therefore also the amount of groups (k) that are being generated.",
                                    sep = " "),
                              paste("The bootstrap strategy repeatedly (k times) generates random distinct samples of observations from the imported dataset.",
                                    "The sampling is done with replacement. The remaining data, out-of-bag samples, serve as test set for the respective",
                                    "iteration and the ratio is adjusted via changing the value of the data split.")),
                 Benchmark = c(paste("A benchmark experiment can be conducted to compare different learners on a task using the same resampling strategy.",
                                     "After generating a benchmark design, a cartesian product between all components, models for each learner",
                                     "are computed. An mlr3 BenchmarkResult-object is generated, storing every model  of each learner for each iteration.",
                                     "By analysing the results, the best algorithm and set of hyperparameters for the present dataset can be detected.",
                                     "Note that using many learners and iterations on a huge dataset increases computation time.",
                                     sep = " "),
                               paste("The workflow can be started on the left-hand side after selecting the learners to be included in the experiment as well as a",
                                     "resampling strategy.",
                                     "Hyperparameters for the resampling strategy can be adjusted similary to the 'Resampling' tab.",
                                     "An aggregated perfomance for every learner can be computed afterwards. The best learner will be displayed in the overview",
                                     "while the score of each learner is depicted in a table on the right-hand side.",
                                     "Also. the BenchmarkResult-object can be downloaded in order reuse it at a later time.",
                                     sep = " ")),
                 Predict = c(paste("After evaluating different learners and parameter sets, a final model can be computed on the entire training data",
                                   "using the most promising algorithm and settings.",
                                   "The learner can then be applied to a new dataset of the same structure as the training data to predict the response",
                                   "of the target variable for each observation. If the new dataset consists of more features than the training data only the feature subset",
                                   "used in training will be referenced for prediction.",
                                   sep = " "),
                             paste("The desired learner needs to be selected and trained.",
                                   "The resulting object can be downloaded for future use",
                                   "A new dataset can be imported with the same procedure as before.",
                                   "Afterwards, the trained model can be used to make a prediction which is displayed on the left-hand side.",
                                   "The prediction can be downloaded either as a csv-file or as a rds-file if it is to be included directly in another R session.")),
                 
                 Explain = c(paste("For further use in different domains, it can be of considerable advantage to understand the internal 
                 \"ways of thinking\" of the algorithms used, which lead to the eventual calculation of the results. 
                 Following the Explainable AI approach, model agnostic methods are used here via the 
                 <a href='https://github.com/ModelOriented/DALEX'>DALEX</a> framework to graphically analyse your model.
                 Implemented are feature importance, as well as methods for specific feature analysis with PD-Plots and ALE-Plots.
                 As a result, even more complex models can be made relatively easy to understand, 
                 which can be particularly useful in arguing for the use of machine learning in newer 
                 application areas. 
                 <p> More information regarding responsible machine learning can be found on the
                 <a href=\"https://dalex.drwhy.ai\">DALEX</a> website, 
                 which is in close relation to the package itself.</p>",
                 sep = " "),
                 paste("After selecting a learner that has been trained on all data in advance, 
                 the applied methods can be selected via the checkboxes.
                 <h4>Feature Importance </h4>
                 For the feature importance, you can select the applied loss-function as well as the compare method.
                 The compare method can be used to select whether the importance should be displayed as a difference 
                 or as a ratio. 
                 After the computation, you will see a plot of the different features and bars indicating their loss.
                 The higher the loss is, the more influence the feature has on the target variable.
                 <h4> Specific feature analysis </h4> 
                  For the feature analysis, you can pick between PD-Plots, ALE-Plots and ICE-Plots. 
                  You can pick features manually with the manual select option or choose a number of
                  features to be picked automaticially, if you choose the automatic option.
                  (Currently, it is only able to display one type of feature (numeric, ordered etc.) at a time).
                  The displayed plots visualize how the values of selected features influence the final prediction.")

                 )
)

#future TO-DO: implement additional learners, ultimately replace vector with as.data.table(mlr_learners)
possiblelearners <- c("Logistic Regression" = "log_reg",
                      "Random Forest" = "ranger",
                      "Decision Tree" = "rpart",
                      "Support Vector Machine" = "svm",
                      "Linear Regression" = "lm",
                      "Extreme Gradient Boosting (xgboost)" = "xgboost")

#log_reg and lm without params
learnerparams <- list(ranger = c("num.trees", "mtry", "min.node.size"),
                     rpart = c("minsplit", "cp", "maxdepth"),
                     supportvm = c("kernel", "cost", "gamma", "degree"),
                     xgboost = c("eta", "max_depth", "nrounds", "colsample_bytree", "booster")
                      )


msr_translations <- data.table(key_msr = c('classif.acc', 'classif.bacc', 'classif.ce', 'classif.logloss',
                                           'classif.auc', 'classif.fnr', 'classif.fpr', 'classif.npv',
                                           'classif.precision', 'classif.specificity', 'classif.recall',
                                           'regr.mae', 'regr.mse', 'regr.rmse', 'regr.rsq'),
                               name = c('accuracy', 'balanced accuracy', 'classification error', 'log loss',
                                        'area under the ROC curve', 'false negative rate', 'false positive rate', 'negative predictive value',
                                        'positive predictive value (precision)', 'true negative rate (specificity)', 'true positive rate (recall/sensitivity)',
                                        'mean absolute error', 'mean squared error', 'root mean squared error', 'r squared'
))

avail_msrs <- as.data.table(mlr_measures) # get all mlr3 measures
get_msrs <- function(current_task, current_learner, available_measures, measure_translations){
  # Checks for task type and subtype and returns available measures for input selection option
  # parameters: current task, current_learner, all measures, measure translations
  # output: mlr3 measure and real name

  make_named_vec <- function(options) {
    temp_opts <- as.list(options[[1]])
    names(temp_opts) <- options[[2]]
    return(temp_opts)
  }
  if (current_task$task_type == 'regr'){
    keys <- available_measures[which(available_measures$task_type == current_task$task_type)][['key']]
  }
  # check for classif as regression has no subtypes (properties)
  else if (current_task$task_type == 'classif' & current_task$properties == 'twoclass') {
    keys <- available_measures[which(available_measures$task_type == 'classif' &
                                       available_measures$predict_type == 'response' |
                                       available_measures$predict_type == 'prob')][['key']]
      }
  else  {
    keys <- intersect(available_measures[which(available_measures$task_type == current_task$task_type &
                                                 available_measures$predict_type == current_learner$predict_type)][['key']],
                      available_measures[which(sapply(available_measures$task_properties, function(x) !is.element('twoclass', x)))][['key']])
  }
  options <- measure_translations[which(measure_translations$key_msr %in% keys), ]
  return(make_named_vec(options))
}

# condition handling
errorModal <- function(title, description, id, err) {
  showModal(
    modalDialog(
      title = h2(title, style = "text-align: center;"),
      h4(description),
      HTML("</br>"),
      h4(paste("Error:", err, sep =  " ")),
      easyClose = TRUE, fade = FALSE,
      footer = div(style = "display:inline-block;width:100%;text-align: center;",
                   actionButton(inputId = id, label = "OK", `data-dismiss` = "modal",
                                style = "background-color: rgb(174, 222, 244); padding: 10px 32px; margin: 26px 5px 0;")))
  )
}

errorAlertTrain <- function(error) {
  errorModal(title = "Model Training Failed",
             description = paste("It seems that the selected learner does not fully support the current data.",
                                 "Please review the dataset and check if the learner can work with all features present.",
                                 sep = " "),
             err = error$message,
             id = "okTrain")
}


errorAlertPredict <- function(error) {
  errorModal(title = "Predicting Target Failed",
             description = paste("Sorry, predicting the target variable of the training or test data did not work.",
                                 "Please have a look at the error message to get insight into the cause.", sep = " "),
             err = error$message,
             id = "okPredict")
}

errorAlertPredictNew <- function(error) {
  errorModal(title = "Predicting Target Failed",
             description = paste("Sorry, predicting the target variable of the newly imported dataset did not work.",
                                 "Please have a look at the error message to get insight into the cause.", sep = " "),
             err = error$message,
             id = "okPredict")
}

errorAlertResample <- function(error) {
  errorModal(title = "Resampling Failed",
             description = paste("Sorry, performing the resampling strategy did not work.",
                                 "Perhaps a resampling parameter did not support the value it was given,",
                                 "the selected learner is incompatible with some of the training data or",
                                 "the test data contain new factor levels that the model cannot handle.",
                                 "Please have a look at the error message to get insight into the cause.", sep = " "),
             err = error$message,
             id = "okResample")
}

errorAlertBench <- function(error) {
  errorModal(title = "Benchmark Failed",
             description = paste("Sorry, computing the benchmark failed.",
                                 "Perhaps a value of the resampling parameter settings is not supported,",
                                 "one of the selected learners is incompatible with some of the training data or",
                                 "the test data contain new factor levels that the model cannot handle.",
                                 "Otherwise, please have a look at the error message to get insight into the cause.", sep = " "),
             err = error$message,
             id = "okBench")
}

errorAlertBenchAggr <- function(error) {
  errorModal(title = "Benchmark Aggregation Failed",
             description = paste("Sorry, calculating an aggregated performance for the benchmark failed.",
                                 "Most likely, the selected learners have different prediction types.",
                                 "For the calculation to succeed, all learners need the same prediction type - response or probability.",
                                 "You can set the prediction type in the Learner-Tab.",
                                 sep = " "),
             err = error$message,
             id = "okBench")
}


warningAlert <- function(warning) {
  showNotification(warning$message, type = "warning")
}

messageDetail <- function(msg) {
  showNotification(msg, type = "message")
}

# reactive values for the predict tab
Pred <- reactiveValues(Learner = NULL, Learner_Ov = NULL, New_Data = NULL, Pred = NULL)

## Functions
# learner selection and overview
getLrnsUi <- function() {
  if (is.null(LearnerMeta$Learner_Avail)) {
    ui <- tagList(
      fluidRow(
        column(12,
               h5("No learner has been created yet.")
        )
      )
    )
    return(ui)
  }
  else {
    ui <- tagList(
      fluidRow(
        column(12,
               radioButtons(inputId = "Pred_learner", label = h5("Select the best learner to train on the entire training data:"),
                                  choices = LearnerMeta$Learner_Avail,
                                  selected = character(0))
        )
      )
    )
    return(ui)
  }
}

getLrnStatus <- function() {
  if (is.null(Pred$Learner$model)) {
    status <- "[not trained]"
  }
  else {
    status <- "trained"
  }
  return(status)
}

# learner overview
createPredLrnOv <- function() {
  overview <- list(
    Learner <- paste(input$Pred_learner, Pred$Learner$label, sep = " "),
    # from server_Learner
    PredType <- Pred$Learner$predict_type,
    Target <- currenttask$task$target_names,
    Status <- getLrnStatus()
  )
  return(overview)
}

getLrnOverview <- function() {
  if (is.null(Pred$Learner)) {
    ui <- tagList(
      hr(style = "border-color: #3e3f3a;"),
      fluidRow(
        column(12,
               h5("No learner has been selected yet.")
        )
      )
    )
    return(ui)
  }
  else {
    overviewui <- tagList(
      hr(style = "border-color: #3e3f3a;"),
      fluidRow(
        column(12,
               addOverviewLineWf("Learner: ", Pred$Learner_Ov[[1]]),
               #addOverviewLineWf("Parameter: ", Pred$Learner_Ov[[2]]),
               addOverviewLineWf("Predict Type", Pred$Learner_Ov[[2]]),
               addOverviewLineWf("Target:", Pred$Learner_Ov[[3]]),
               addOverviewLineWf("Status:", Pred$Learner_Ov[[4]])
        )
      )
    )
    return(overviewui)
  }
}

getLrnTrainBtn <- function() {
  if (!is.null(Pred$Learner)) {
    lrnbutton <- tagList(
      hr(style = "border-color: #3e3f3a;"),
      fluidRow(
        column(12,
               actionButton(inputId = "Pred_train_learner", label = "Train Learner", style = "float: left;"),
               if (!is.null(Pred$Learner$model)) {
                  downloadButton(outputId  = "Pred_trained_learner", label = "Export learner", style = "float: right;")
               } else {
                 hidden (
                  downloadButton(outputId  = "Pred_trained_learner", label = "Export learner", style = "float: right;")
                  )
                  }
        )
      )
    )
  }
}
getNewDataTbl <- function() {
  if (!is.null(Pred$New_Data)) {
    tabl <- DT::datatable(as.data.table(Pred$New_Data),
                          options = list(scrollX = TRUE,searching = FALSE, bInfo = FALSE, lengthChange = FALSE, scrollY = "150px"))
    return(tabl)
  }
}

getNewPrediction <- function() {
  if (!is.null(Pred$Pred)) {
    tabl <- DT::datatable(as.data.table(Pred$Pred),
                          options = list(scrollX = TRUE,searching = FALSE, bInfo = FALSE, lengthChange = FALSE, scrollY = "150px"))
    return(tabl)
  }
}

getLrnCodegenBtn <- function() {
  if (!is.null(Pred$Learner)) {
    lrnbutton <- tagList(
      hr(style = "border-color: #3e3f3a;"),
      fluidRow(
        column(12,
            hidden(
            actionButton(inputId = "Pred_codegen", label = "Show the Code", icon = icon("code"), style = "stretch", width = "100%")
            )
        )
      )
    )
  }
}

## ouputs and observers

#learner selection
output$Predict_learner_choice <- renderUI({
  getLrnsUi()
})

#lerner overview and train button
output$Predict_learner_overview <- renderUI({
  getLrnOverview()
})

output$Predict_learner_train_btn <- renderUI({
  getLrnTrainBtn()
})

# code-generation button
output$Predict_codegen_btn <- renderUI({
  getLrnCodegenBtn()
})

# train learner
observeEvent(input$Pred_train_learner, {
    withProgress(message = "Training model on all data", {
      withCallingHandlers(
        tryCatch({
          trained_learner_list[[input$Pred_learner]] <- Pred$Learner$train(currenttask$task)
          Pred$Learner <- trained_learner_list[[input$Pred_learner]]
        }
        , error = errorAlertTrain),
        warning = warningAlert)
      incProgress(0.8)
      show(id = "Pred_trained_learner")
      show(id = "Pred_codegen")
    })
    print(Pred$Learner$param_set)
  Pred$Learner_Ov <- createPredLrnOv()
})

# display generated code when the button is pressed
observeEvent(input$Pred_codegen, {
  showModal(
    modalDialog(
      title = h2("Code Generation", style = "text-align: center;"),
      h4("## Task Creation"),
      HTML(get_task_code(currenttask$task)),
      h4("## Learner Creation"),
      HTML(get_learner_code(Pred$Learner)),
      h4("## Training"),
      HTML(get_training_code()),
      h4("## Scoring"),
      HTML(get_score_code(currenttask$task, Pred$Learner)),
      h4("## Resampling"),
      HTML(get_resampling_code()),
      h4("## Final Training and Predict"),
      HTML(get_final_training_code(currenttask$task, Pred$Learner)),
      easyClose = TRUE,
      footer = div(style = "display:inline-block;width:100%;text-align: center;",
                   modalButton('OK')))
      )
})

# download learner
output$Pred_trained_learner <- downloadHandler(
  filename = function() {
    paste(paste("Trained_Learner", Pred$Learner$id, sep = "_"), ".rds", sep = "")
  },
  content = function(file) {
    saveRDS(Pred$Learner, file = file)
  }
)

# get new data import
observe({
  if (input$Predict_data_type == "csv" || input$Predict_data_type == "txt") {
    filepath <-  input$Predict_data_csv$datapath
    if (!is.null(filepath) && (str_sub(filepath, -4, -1) == ".csv" || (str_sub(filepath, -4, -1) == ".txt" ))) {
      Pred$New_Data <- read.csv(file = filepath, header = input$Predict_data_header,
                                   sep = input$Predict_data_sep, quote = input$Predict_data_quote)
    }
  } else if (input$Predict_data_type == "xlsx") {
     filepath <-  input$Predict_data_xlsx$datapath
        if (!is.null(filepath) && (str_sub(filepath, -5, -1) == ".xlsx" )) {
          predicttibble <- read_excel(path = filepath, col_names = input$Predict_data_header_xlsx,
                                         sheet = input$Predict_data_sheet)
          predictdf <- as.data.frame(predicttibble)
          Pred$New_Data <- modify_at(predictdf,
                                        which(as.character(sapply(predictdf, class)) == "character"),
                                        as.factor)
    }
  } else if (input$Predict_data_type == "spss") {
    filepath <-  input$Predict_data_spss$datapath
    if (!is.null(filepath) && (str_sub(filepath, -4, -1) == ".sav" | str_sub(filepath, -4, -1) == ".por") ) {
      predicttibble <- read_spss(file = filepath)
      predictdf <- as.data.frame(predicttibble)
      predictdf <- as_factor(predictdf)
      Pred$New_Data <- modify_at(predictdf,
                                  which(as.character(sapply(predictdf, class)) == "character"),
                                  as.factor)
    }
  } else if (input$Predict_data_type == "sas") {
    filepath <-  input$Predict_data_sas$datapath
    if (!is.null(filepath) && (str_sub(filepath, -9, -1) == ".sas7bdat") ) {
      predicttibble <- read_sas(data_file = filepath)
      predictdf <- as.data.frame(predicttibble)
      Pred$New_Data <- modify_at(predictdf,
                                  which(as.character(sapply(predictdf, class)) == "character"),
                                  as.factor)
    }
  } else if (input$Predict_data_type == "stata") {
    filepath <-  input$Predict_data_stata$datapath
    if (!is.null(filepath) && (str_sub(filepath, -4, -1) == ".dta") ) {
      predicttibble <- read_stata(file = filepath)
      predictdf <- as.data.frame(predicttibble)
      Pred$New_Data <- modify_at(predictdf,
                                  which(as.character(sapply(predictdf, class)) == "character"),
                                  as.factor)
    }
  }
})

observe({
  toggle(id = "Pred_well_new_data", condition = !is.null(Pred$New_Data))
})

output$Pred_new_data_view <- DT::renderDataTable({
  getNewDataTbl()
})

# make the prediction
observeEvent(input$Predict_predict, {
  if (is.null(Pred$Learner) || is.null(Pred$New_Data)) {
    shinyalert(title = "Predicting Failed",
               text = paste("Please train a learner on the entire training data set and import a new dataset prior to predicting.",
                            "the target value", sep = " "),
               closeOnClickOutside = TRUE,
               animation = FALSE,
               className="alert-warning",
               )
  }
  else {
    withCallingHandlers(
      tryCatch(Pred$Pred <- Pred$Learner$predict_newdata(task = currenttask$task, newdata = Pred$New_Data[, features_to_use$features]),
               error = errorAlertPredictNew),
      warning = warningAlert)
  }
})

observe({
  toggle(id = "Pred_well_prediction", condition = !is.null(Pred$Pred))
})

output$Pred_prediction_view <- DT::renderDataTable({
  getNewPrediction()
})

# download prediction as csv or rds
output$Pred_prediction_download_csv <- downloadHandler(
  filename = function() {
    paste("Prediction_new_data", ".csv", sep = "")
  },
  content = function(file) {
    write.csv(x = as.data.table(Pred$Pred), file = file)
  }
)
output$Pred_prediction_download_rds <- downloadHandler(
  filename = function() {
    paste("Prediction_new_data", ".rds", sep = "")
  },
  content = function(file) {
    saveRDS(object = Pred$Pred, file = file)
  }
)

# reset Learner
resetPredLrn <- function() {
  Pred$Learner <- NULL
  Pred$Learner_Ov <- NULL
  reset_trained_learner_list()
}


observeEvent(input$Pred_learner, {
  if (!is.null(trained_learner_list[[input$Pred_learner]])) {
    Pred$Learner <- trained_learner_list[[input$Pred_learner]]
  } else {
    Pred$Learner <- get(input$Pred_learner)$Learner$clone(deep = TRUE)
  }
  Pred$Learner_Ov <- createPredLrnOv()
})

observeEvent(currenttask$task, {
  resetPredLrn()
})
quote_seperator <- NULL
## Functionality for code generation
# get code-block for task generation
get_task_code <- function(task) {
  task_code <- NULL
  task_code <- paste0(task_code, "# include libraries <br>")
  task_code <- paste0(task_code, "library(mlr3) <br>")
  task_code <- paste0(task_code, "library(mlr3learners) <br>")
  task_code <- paste0(task_code, "library(mlr3pipelines) <br>")
  if (task$id == "iris" || task$id == "mtcars" || task$id == "german_credit") {
    task_code <- paste0(task_code, "# using pre-defined mlr3-tasks <br>")
    task_code <- paste0(task_code, "task <- tsk(\"", task$id,"\") <br>")
  } else {
    # checking if quote is set as " or ' and choose the other one in read.csv so its either "'" or '"'
    if (input$Data_train_quote == "'") {
      quote_seperator <- '"'
    } else {
      quote_seperator <- "'"
    }
    task_code <- paste0(task_code, "# creating custom task from input data <br>")
    # building the read.csv using the user input
    task_code <- paste0(task_code, "data <-read.csv(file = \"path_to_file\", header= ",
      input$Data_train_header, ", sep = \"", input$Data_train_sep, "\", quote =", quote_seperator,
      input$Data_train_quote,  quote_seperator, ", stringsAsFactors = TRUE) <br>")
    if (is.numeric(currenttask$target)) {
      task_code <- paste0(task_code,
      "task <- TaskRegr$new(id = \"newData\", backend = data, target = ",
      input$Task_target, ")")
    } else if (is.factor(currenttask$target)) {
      task_code <- paste0(task_code,
      "task <- TaskClassif$new(id = ", input$Task_id, ", backend = data, target = ",
      input$Task_target, ")")
    }
  }
  return(task_code)
}

## old version
# get_learner_code <- function(learner) {
#   # creating initial graph
#   learner_code <- "# create initial graph <br>"
#   learner_code <- paste0(learner_code, "graph <- Graph$new() <br>")
#   # adding graph learner to graph
#   learner_name <- learner$graph$ids()[grep("\\.", learner$graph$ids())]
#   learner_code <- paste0(learner_code, "# adding learner PipeOp <br>")
#   if(!isTRUE(currenttask$task$properties == "twoclass")){
#     learner_code <- paste0(learner_code, "graph$add_pipeop(lrn(\"", learner_name, "\", predict_type = \"", learner$predict_type, "\")) <br>")
#     }
#   if(isTRUE(currenttask$task$properties == "twoclass")){
#     learner_code <- paste0(learner_code, "graph$add_pipeop(lrn(\"", learner_name, "\", predict_type = \"prob\")) <br>")
#   }
#   if (any(grepl("encode", learner$graph$ids()))) {
#     learner_code <- paste0(learner_code,
#     "# adding a PipeOp to enable the usage of factor columns for the chosen learner <br>")
#     learner_code <- paste0(learner_code,
#     "graph <- po(\"encode\", method = \"treatment\", affect_columns = selector_type(\"factor\")) %>>% graph <br>")
#   }
#   if (any(grepl("colapply", learner$graph$ids()))) {
#     learner_code <- paste0(learner_code, "# adding a colapply PipeOp  <br>")
#     learner_code <- paste0(learner_code,
#     "graph <- po(\"colapply\", applicator = as.integer, affect_columns = selector_type(\"ordered\")) %>>% graph <br>")
#   }
#   if(isTRUE(currenttask$task$properties == "twoclass")){
#     learner_code <- paste0(learner_code, "# adding a threshold PipeOp for twoclass task <br>")
#     learner_code <- paste0(learner_code, "graph <- graph %>>% po(\"threshold\") <br>")
#   }
#   for (parameter in names(learner$param_set$values)) {
#     learner_code <- paste0(learner_code, "graph$param_set$values$", parameter, "<- ", learner$param_set$values[parameter], "<br>")
#   }
# 
#   learner_code <- paste0(learner_code, "# saving the graph as a GraphLearner <br>")
#   learner_code <- paste0(learner_code, "learner <- as_learner(graph) <br>")
#   return(learner_code)
# }

get_learner_code <- function(learner) {
  learner_name <- learner$graph$ids()[grep("\\.", learner$graph$ids())]
  # creating initial learner
  learner_code <- "# create initial learner <br>"
  if(!isTRUE(currenttask$task$properties == "twoclass")){
    learner_code <- paste0(learner_code, "learner <- lrn(\"", learner_name, "\") <br>")
  }
  if(isTRUE(currenttask$task$properties == "twoclass")){
    learner_code <- paste0(learner_code, "graph$add_pipeop(lrn(\"", learner_name, "\", predict_type = \"prob\")) <br>")
  }  
  
  # create graph learner
  learner_code <- paste0(learner_code, "# create graph of processing chain <br>")
  if(input[["Task_robustify"]]){
    learner_code <- paste0(learner_code, "graph <- pipeline_robustify(task, learner) %>>% learner <br>")
    learner_code <- paste0(learner_code, "# (Note: Additional hyperparameters for robustification can be specified.) <br>")
    
  }
  if(!input[["Task_robustify"]]){
    learner_code <- paste0(learner_code, "graph <- as_graph(po(\"learner\", learner)) <br>")
  }
  
  if (isTRUE(currenttask$task$properties == "twoclass")){
    learner_code <- paste0(learner_code, "# add threshold parameter for twoclass classification <br>")
    learner_code <- paste0(learner_code, "graph <- graph %>>% po(\"threshold\") <br>")
  } 
  
  learner_code <- paste0(learner_code, "# saving the graph as a GraphLearner <br>")
  learner_code <- paste0(learner_code, "learner <- as_learner(graph) <br>")

  # set parameters
  possibleparams <- c("threshold",
                       "rpart.minsplit","rpart.maxdepth","rpart.cp",
                       "ranger.num.trees", "ranger.mtry", "ranger.min.node.size",
                       "svm.kernel","svm.cost", "svm.gamma", "svm.degree",
                       "xgboost.eta", "xgboost.max_depth", "xgboost.nrounds", "xgboost.colsample_bytree", "xgboost.booster")
  # REM: ugly brute force list of currently implemented learners/parameters. should ideally be created automatically (problem: some nonempty fileds in graph$param_set$value although not specified
  
  pars_set <- 0
  for (parameter in names(learner$param_set$values)) {
      inlist <- sapply(possibleparams, function(z) length(grep(z, parameter)))
      if(any(inlist > 0)) {
        pars_set <- pars_set + 1
        if(pars_set == 1) learner_code <- paste0(learner_code, "<br># set hyperparameters <br>")
        learner_code <- paste0(learner_code, "graph$param_set$values$", parameter, " <-  ", learner$param_set$values[parameter], "<br>")
        }
  }
  return(learner_code)
  
}


get_training_code <- function() {
  train_code <- NULL
  if (!is.null(input$TrainFit_seed)) {
    train_code <- paste0(train_code,
    "# setting the seed for reproduction <br>", "set.seed(", input$TrainFit_seed, ") <br>")
  }
  train_code <- paste0(train_code, "# creating split for test and training data <br>")
  if (!is.null(input$TrainFit_input_split)) {
    train_code <- paste0(train_code, "# using the split set by the user <br>")
    train_code <- paste0(train_code, "train_data <- sample(task$row_ids, task$nrow*",
      input$TrainFit_input_split / 100, ") <br>")
  } else {
    train_code <- paste0(train_code, "# using default 80/20 split <br>")
    train_code <- paste0(train_code, "train_ids <- sample(task$row_ids, task$nrow*0.8) <br>")
  }
  train_code <- paste0(train_code, "test_ids <- setdiff(task$row_ids, train_ids) <br>")
  train_code <- paste0(train_code, "# training the model <br>")
  train_code <- paste0(train_code, "learner$train(task, row_ids = train_ids) <br>")
  train_code <- paste0(train_code, "# predicting on the training and test data <br>")
  train_code <- paste0(train_code, "train_pred <- learner$predict(task, row_ids = train_ids) <br>")
  train_code <- paste0(train_code, "test_pred <- learner$predict(task, row_ids = test_ids) <br>")
  return(train_code)
}

get_score_code <- function(task, learner) {
  score_code <- NULL
  score_code <- paste0(score_code, "# scoring the test prediction with one of the following measures <br>")
  score_code <- paste(score_code,
  "# available measures: ", toString(unname(get_msrs(task, learner, avail_msrs, msr_translations))), "<br>")
  score_code <- paste0(score_code,
  "measure <- msr(\"",unname(get_msrs(task, learner, avail_msrs, msr_translations))[1], "\") <br>")
  score_code <- paste0(score_code, "test_pred$score(measure) <br>")
  return(score_code)
}

get_resampling_code <- function() {
  resampling_code <- "# performing resampling <br>"
  resampling_code <- paste0(resampling_code, "# possible strategies: cv, holdout, bootstrap <br>")
  resampling_code <- paste0(resampling_code, "# example for holdout with a set ratio: <br>")
  resampling_code <- paste0(resampling_code, "resampling <- rsmp(\"holdout\", ratio = 0.5) <br>")
  resampling_code <- paste0(resampling_code, "# more information regarding possible strategies <br>")
  resampling_code <- paste0(resampling_code,
  "# and their parameters can be found here:
  <a href=\"https://mlr3book.mlr-org.com/resampling.html\">mlr3 manual</a><br>")
  resampling_code <- paste0(resampling_code, "rr <- resample(task, learner, resampling)<br>")
  resampling_code <- paste0(resampling_code,
  "# evaluating the performance across all resampling iterations using the already defined measure<br>")
  resampling_code <- paste0(resampling_code, "rr$aggregate(measure)<br>")
  return(resampling_code)
}

get_final_training_code <- function(task, learner) {
  if (input$Predict_data_quote == "'") {
    quote_seperator <- '"'
  } else {
    quote_seperator <- "'"
  }

  final_train_code <- "# training the model on the whole dataset <br>"
  final_train_code <- paste0(final_train_code, "learner$train(task) <br>")
  if (!is.null(input$Data_train_type)) {
  final_train_code <- paste0(final_train_code, "# read new data<br>")
  final_train_code <- paste0(final_train_code, "new_data <-read.csv(file = \"path_to_file\", header= ",
  input$Predict_data_header, ", sep = \"", input$Predict_data_sep, "\", quote =", quote_seperator,
  input$Predict_data_quote, quote_seperator, ", stringsAsFactors = TRUE) <br>")
  final_train_code <- paste0(final_train_code, "# predict on new data <br>")
  final_train_code <- paste0(final_train_code, "learner$predict_newdata(task, newdata = new_data)")
  } else {
  final_train_code <- "# predicting on the whole dataset <br>"
  final_train_code <- paste0(final_train_code, "learner$predict(task) <br>")
  }
  return(final_train_code)
}

observe({
  toggle(id = "Pred_well_decision_tree", 
  condition = !is.null(input$Pred_learner)
    && ((Pred$Learner$graph_model$output$op.id %in% c("classif.rpart", "regr.rpart")) 
    | !is.null(Pred$Learner$graph_model$pipeops$classif.rpart)))
    #last part of condition is needet for twoclass classifcations
})

raise_alert <- function(message, bttn_confirm=FALSE) {
  if (!bttn_confirm) {
    shinyalert(
      title = "Warning",
      text = message,
      animation = FALSE,
      showConfirmButton = TRUE,
      className="alert-warning",
      )
  }
  else {
    shinyalert(
      title = "Warning",
      text = message,
      animation = FALSE,
      showCancelButton = TRUE,
      showConfirmButton = TRUE,
      className="alert-warning",
      callbackR = function(x) {if (x == TRUE) {render_decision_tree(TRUE)}})
  }
}

render_decision_tree <- function(decision_overwrite=FALSE) {
  node_limit <- 15
  if (!is.null(Pred$Learner$graph_model$pipeops$classif.rpart)) {
    nodes <- nrow(Pred$Learner$graph_model$pipeops$classif.rpart$learner_model$model$frame)
    if (nodes <= node_limit | decision_overwrite) {
      output$plot_decision_tree <- renderPlot(autoplot(Pred$Learner$graph_model$pipeops$classif.rpart$learner_model, type="ggparty"))
    }
    else {
      raise_alert(sprintf("Decision Tree might take a while to render and might not fit the designated space, because there are many (%s) nodes", nodes), TRUE)
    }
    
  }
  else if (Pred$Learner$graph_model$output$op.id == "regr.rpart") {
      nodes <- nrow(Pred$Learner$graph_model$pipeops$regr.rpart$learner_model$model$frame)
      if (nodes <= node_limit | decision_overwrite) {
        output$plot_decision_tree <- renderPlot(autoplot(Pred$Learner$graph_model$pipeops$regr.rpart$learner_model, type="ggparty"))
      }
      else {
        raise_alert(sprintf("Decision Tree might take a while to render and might not fit the designated space, because there are many (%s) nodes", nodes), TRUE)
      }
  }
  else (
    raise_alert("Error: No decision tree")
  )
}

observeEvent(input$action_visualize_predict, {
  if (Pred$Learner_Ov[[4]] == "trained") {
    output$show_viz <- reactive(TRUE)
    outputOptions(output, "show_viz", suspendWhenHidden = FALSE)
    render_decision_tree()
  }
  else {
    raise_alert("Learner must be trained to visualize decision tree")
  }
  
})

output$plotDecisionTree <- renderUI({
  tagList(
    conditionalPanel(condition="output.show_viz == true", plotOutput(outputId = "plot_decision_tree"))
    )
})

observeEvent(input$Pred_learner, {
  output$plot_decision_tree <- renderPlot({})
  output$show_viz <- reactive(FALSE)
    outputOptions(output, "show_viz", suspendWhenHidden = FALSE)
})
